#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
bool chkmax(int &x, const int &y) { return x < y ? x = y, 1 : 0; }
bool chkmin(int &x, const int &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (1 << 20);

int n, p[MAXN], c[MAXN];

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++) cin >> p[i];
    for(int i = 1; i <= n; i++) cin >> c[i];
}

vector<pair<int, int> > answer;

void SWAP(int i, int j)
{
    answer.pb({i, j});
    swap(p[i], p[j]);
    swap(c[i], c[j]);
}

set<int> can_rem;

void solve()
{
    for(int i = 1; i <= n; i++)
        if(c[p[i]] != c[i])
            can_rem.insert(i);

    while(!can_rem.empty())
    {
        int i = *can_rem.begin();
        
        can_rem.erase(i);
        can_rem.erase(p[i]);
        
        SWAP(i, p[i]);
        
        if(c[i] != c[p[i]]) can_rem.insert(i);
        if(c[p[i]] != c[p[p[i]]]) can_rem.insert(p[i]);
        
    }

    cout << SZ(answer) << endl;
    for(auto it: answer)
        cout << it.first << " " << it.second << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    read();
    solve();
    return 0;
}
