#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
bool chkmax(int &x, const int &y) { return x < y ? x = y, 1 : 0; }
bool chkmin(int &x, const int &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = 54;

int64_t n, l;
int64_t a[MAXN];

void read()
{
    cin >> n >> l;
    for(int i = 0; i < n; i++)
    {
        string s;
        cin >> s;
        for(int64_t j = 0; j < l; j++)
            if(s[j] == '1') a[i] |= (1ll << j);
    }
}

vector<int> adj[MAXN];

bool check(int64_t mask)
{
    /*
    for(int i = 0; i < l; i++)
        adj[i].clear();

    for(int i = 0; i < n; i++)
        for(int64_t bit = 0; bit < l; bit++)
            if(((mask & a[i]) & (1ll << bit)))
                adj[bit].pb(i);
    */
     
    vector<int> perm(n, 0);
    for(int i = 0; i < n; i++) perm[i] = i;
    for(int tries = 0; tries < 5000; tries++)
    {
        random_shuffle(ALL(perm));
        
        int64_t ret = 0;
        for(int i: perm)
        {
            int64_t q = (mask & ret), p = (mask & a[i]);
            if(q & p) continue;
            ret |= p;
        }

        if(ret == mask)
            return true;
    }

    return false;
}

void solve()
{
    int64_t ans = 0;
    for(int64_t i = 0; i < l; i++)
    {
        ans |= (1ll << i);
        if(!check(ans)) 
        {
            ans ^= (1ll << i);
            cout << '0';
        }
        else cout << '1';
    }

    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    read();
    solve();
    return 0;
}
