#include<iostream>
#include<vector>
#include<queue>
#include<algorithm>
#include<cstring>
using namespace std;
int n;
int p[1000005],w[1000005];
vector<pair<int,int> > v[100005];
long long ans;



long long hook,wh;
vector<pair<long long,long long> > nextV[1000005];
bool used[1000005];

void makeTree (long long pos)
{
    used[pos]=true;
    for (long long i=0; i<v[pos].size(); i++)
    {
        if (used[v[pos][i].first])
            continue;
        nextV[pos].push_back(v[pos][i]);
        makeTree(v[pos][i].first);
    }
}
bool cmp (long long x, long long y)
{
    return x>y;
}
long long solve (long long pos)
{
    if (nextV[pos].size()==0)
        return 0;
    vector<long long> z;
    for (long long i=0; i<nextV[pos].size(); i++)
        z.push_back((long long)solve(nextV[pos][i].first)+nextV[pos][i].second);

    if (z.size()==1)
    {
        ans=max(ans,z[0]);
        return z[0];
    }
    sort(z.begin(),z.end(),cmp);
    ans=max(ans,z[0]+z[1]);
    return z[0];
}

short usd[1000005];
int pred[1000005];
vector<int> cycle;
vector<long long> cweight,treeweight;
bool cyclefound=false;
int positions[1000005];
void findCycle (int pos)
{
    if (cyclefound)
        return;
    usd[pos]=2;
    for (int i=0; i<v[pos].size(); i++)
    {
        if (usd[v[pos][i].first]==2 && v[pos][i].first!=pred[pos])
        {
            cyclefound=true;
            int o=pos;
            while (o!=v[pos][i].first)
            {
                cycle.push_back(o);
                o=pred[o];
            }
            cycle.push_back(o);
        }
        if (!usd[v[pos][i].first])
        {
            pred[v[pos][i].first]=pos;
            findCycle(v[pos][i].first);
        }
    }
    usd[pos]=1;
}
void buildPositions()
{
    for (int i=0; i<cycle.size(); i++)
        positions[cycle[i]]=i;
}
void buildWeights()
{
    for (int i=1; i<cycle.size(); i++)
    {
        int x=cycle[i-1],y=cycle[i];
        for (int j=0; j<v[x].size(); j++)
            if (v[x][j].first==y)
                cweight.push_back(v[x][j].second);
    }

    int x=cycle[cycle.size()-1];
    int y=cycle[0];

    for (int j=0; j<v[x].size(); j++)
        if (v[x][j].first==y)
            cweight.push_back(v[x][j].second);
}

void manageIntervals()
{
    long long sum=0;
    for (int i=0; i<cweight.size(); i++)
        sum+=cweight[i];


    //cout<<sum<<'\n';

    for (int l=0; l<cycle.size(); l++)
    {
        int r=(l+1)%cycle.size();
        long long part=cweight[l];

        while (r!=l)
        {
            if (part<=sum/2)
                ans=max(ans,part+treeweight[l]+treeweight[r]);
            else
                break;
            //cout<<l<<' '<<r<<' '<<part<<'\n';
            r++;
            part+=cweight[r-1];
            r=r%cweight.size();
        }
    }
}

void buildNext2(int pos)
{
    for (int i=0; i<v[pos].size(); i++)
        if (!usd[v[pos][i].first])
        {
            usd[v[pos][i].first]=1;
            nextV[pos].push_back(v[pos][i]);
            buildNext2(v[pos][i].first);
        }
}
void manageTrees()
{
    memset(usd,0,sizeof(usd));
    for (int i=0; i<cycle.size(); i++)
        usd[cycle[i]]=2;
    for (int i=0; i<cycle.size(); i++)
    {
        if (v[cycle[i]].size()==2)
        {
            treeweight.push_back(0);
            continue;
        }
        buildNext2(cycle[i]);
        int r=solve(cycle[i]);
        treeweight.push_back(r);
    }
}

int main()
{
    cin>>n;
    for (long long i=0; i<n; i++)
        cin>>p[i];
    for (long long i=0; i<n; i++)
        cin>>w[i];

    for (long long i=0; i<n; i++)
    {
        long long x=i+1,y=p[i];
        if (x==y)
        {
            hook=x;
            wh=w[i];
            continue;
        }
        v[x].push_back(make_pair(y,w[i]));
        v[y].push_back(make_pair(x,w[i]));
    }

    if (hook!=0)
    {
        makeTree(1);
        solve(1);
    }

    else
    {
        findCycle(1);
        buildWeights();
        buildPositions();

        manageTrees();

        manageIntervals(); ///and pray that it works
    }

    cout<<ans<<'\n';
}
