#include <iostream>
#include <vector>
#include <utility>
#include <random>
using namespace std;

const int MAXN = 100005;

int n;
int a[MAXN], b[MAXN];

int p[MAXN];
vector<pair<int, int>> v;
vector<int> lc[MAXN];

int big[MAXN];

mt19937 rg(4209008);

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    int bg = 0;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        p[a[i]] = i;
        bg = max(bg, a[i]);
    }
    for (int i = 1; i <= n; ++ i)
    {
        int x;
        cin >> x;
        b[a[i]] = x;
        lc[x].push_back(a[i]);
    }

    int bg2 = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (i != b[bg]) big[i] = bg;
        if (b[a[i]] != b[bg]) bg2 = max(bg2, a[i]);
    }
    big[b[bg]] = bg2;
}

void Swap(int x, int y)
{
    v.emplace_back(p[x], p[y]);
    swap(a[p[y]], a[p[x]]);
    swap(p[x], p[y]);
}

int main()
{
    Init();

    for (int i = 1; i <= n; ++ i)
    {
        if (p[i] == i) continue;

        if (b[i] != b[a[i]])
        {
            Swap(i, a[i]);
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        if (p[i] == i) continue;

        if (b[i] != b[a[i]])
        {
            Swap(i, a[i]);
        }
        else if (b[p[i]] != b[i])
        {
            int tmp = p[i];
            Swap(a[i], tmp);
            Swap(i, tmp);
        }
        else
        {
            int tmp = big[b[i]];
            Swap(a[i], tmp);
            Swap(i, tmp);
        }
    }

    cout << v.size() << endl;
    for (int i = 0; i < v.size(); ++ i)
    {
        cout << v[i].first << ' ' << v[i].second << endl;
    }
    return 0;
}

/*
7
2 5 3 7 1 6 4
3 2 2 3 3 2 3
-----
2
2 1
1 2

*/
