#include <iostream>
#include <vector>
#include <ctime>
using namespace std;

const int N=(1e5)+5;

int a[N],c[N];
vector < pair <int,int> > ans;

bool NoTime()
{
 return clock()/(double)CLOCKS_PER_SEC>0.5;
}

int main()
{

ios::sync_with_stdio(false);
cin.tie(nullptr);

int n,i,j,x,y,sz;
bool swapped;

cin>>n;

 for(i=1;i<=n;i++)
  cin>>a[i];

 for(i=1;i<=n;i++)
  cin>>c[i];

 while(1)
 {
   if(NoTime())
    break;

   for(i=1;i<=n;i++)
   {
    if(a[i]!=i)
    {
     x=i;
     y=a[i];

      if(c[x]!=c[y])
      {
       ans.push_back(make_pair(x,y));
       swap(a[x],a[y]);
       swap(c[x],c[y]);
      }
    }
   }

  swapped=true;
   for(i=1;i<=n;i++)
   {
    if(a[i]!=i)
    {
     swapped=false;
     break;
    }
   }

   if(swapped)
    break;

  swapped=false;
   for(i=1;i<=n;i++)
   {
    if(a[i]!=i)
    {
      for(j=i+1;j<=n;j++)
      {
       if(a[j]!=j && c[i]!=c[j])
       {
        ans.push_back(make_pair(i,j));
        swap(a[i],a[j]);
        swap(c[i],c[j]);
        swapped=true;
        break;
       }
      }

      if(swapped)
       break;
    }
   }

   if(!swapped)
   {
    for(i=1;i<=n;i++)
    {
     if(a[i]!=i)
     {
       for(j=i+1;j<=n;j++)
       {
         if(c[i]!=c[j])
         {
          ans.push_back(make_pair(i,j));
          swap(a[i],a[j]);
          swap(c[i],c[j]);
          swapped=true;
          break;
         }
       }

      if(swapped)
       break;
     }
    }
   }
 }

sz=(int)ans.size();

cout<<sz<<"\n";

 for(i=0;i<sz;i++)
  cout<<ans[i].first<<" "<<ans[i].second<<"\n";

return 0;
}
