#include <iostream>
using namespace std;

typedef long long Int;

const int N=105;
const Int LMAX=(1e18);

Int p[N],w[N],dist[N][N];

int main()
{

ios::sync_with_stdio(false);
cin.tie(nullptr);

int n,i,j,k;
Int ans;

cin>>n;

 for(i=1;i<=n;i++)
  for(j=1;j<=n;j++)
   dist[i][j]=LMAX;

 for(i=1;i<=n;i++)
  dist[i][i]=0;

 for(i=1;i<=n;i++)
  cin>>p[i];

 for(i=1;i<=n;i++)
 {
  cin>>w[i];
  dist[i][p[i]]=w[i];
  dist[p[i]][i]=w[i];
 }

 for(k=1;k<=n;k++)
  for(i=1;i<=n;i++)
   for(j=1;j<=n;j++)
   {
    if(dist[i][k]+dist[k][j]<dist[i][j])
     dist[i][j]=dist[i][k]+dist[k][j];
   }

ans=0;
 for(i=1;i<=n;i++)
  for(j=1;j<=n;j++)
   ans=max(ans,dist[i][j]);

cout<<ans<<"\n";

return 0;
}
