#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

#define endl '\n'

using namespace std;

const int N = (int)(1e5) + 3;

int n;
int p[N], c[N];
int positionOf[N];
set<int> s;

int main() {
    //freopen("23.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int i = 1; i <= n; ++i) cin >> p[i], positionOf[p[i]] = i;
    for(int i = 1; i <= n; ++i) cin >> c[i], s.insert(c[i]);

    if((int)s.size() == n) {
        vector< pair<int, int> > op;
        for(int i = 1; i <= n; ++i) {
            if(positionOf[i] != i) {
                int pos1 = positionOf[i];
                int pos2 = positionOf[p[i]];
                int numb = p[i];
                op.push_back(make_pair(pos1, i));
                positionOf[i] = i;
                positionOf[p[i]] = pos1;
                p[i] = i;
                p[pos1] = numb;
            }
        }
        cout << (int)op.size() << endl;
        for(auto i : op) {
            cout << i.first << ' ' << i.second << endl;
        }
    }

    return 0;
}
