#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstring>

#define endl '\n'

#pragma GCC optimize("O3")

using namespace std;

const int N = 53, L = 53;

int n, l;
string a[N], b, res;
bool use[N], blocked[L];

void go(int pos) {
    if(pos == n) {
        memset(blocked, 0, sizeof(blocked));
        bool start = true;
        for(int i = 0; i < n; ++i) {
            if(use[i]) {
                if(start) {
                    b = a[i];
                    start = 0;
                } else {
                    for(int j = 0; j < l; ++j) {
                        if(blocked[j]) continue;

                        if(b[j] == '1') {
                            if(a[i][j] == '1') {
                                b[j] = '0';
                                blocked[j] = 1;
                            }
                        } else {
                            if(a[i][j] == '1') {
                                b[j] = '1';
                            }
                        }
                    }
                }
            }
        }
        if((int)res.size()) {
            if(b > res) res = b;
        } else res = b;
        return;
    }
    use[pos] = 0;
    go(pos + 1);
    use[pos] = 1;
    go(pos + 1);
}

int main() {
    //freopen("31.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> l;

    vector<string> v;

    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        v.push_back(a[i]);
    }

    if(n <= 21) {
        go(0);
        cout << res << endl;
    } else {
        sort(v.begin(), v.end());

        for(auto i : v) {
            cout << i << endl;
        }

    }

    return 0;
}
