#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 7;

int a[N], c[N], curr[N];

vector<pair<int, int> > ans;

void make_swap(int x, int y){
    //cout << "swap " << x << " " << y << endl;

    ans.push_back({x, y});
    swap(a[x], a[y]);
    swap(c[x], c[y]);
    curr[c[x]] = x;
    curr[c[y]] = y;
}

bool used[N];
vector<int> cycle;

void dfs(int x){
    used[x] = true;
    cycle.push_back(x);

    if(!used[a[x]]){
        dfs(a[x]);
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int n, first = 0, second = 0;

    cin >> n;

    for(int i = 1; i <= n; i++){
        cin >> a[i];
    }
    for(int i = 1; i <= n; i++){
        cin >> c[i];
        curr[c[i]] = i;
    }

    for(int i = 1; i <= n; i++){
        if(!first){
            first = c[i];
        }
        else{
            if(c[i] != first){
                second = c[i];
                break;
            }
        }
    }

    for(int i = 1; i <= n; i++){
        if(!used[i]){
            cycle.clear();
            dfs(i);

            if(cycle.size() == 1){
                continue;
            }

            int cnt = 0;

            for(int x: cycle){
                if(c[x] == c[i]){
                    cnt++;
                }
            }

            reverse(cycle.begin(), cycle.end());

            if(cnt == cycle.size()){
                int other, pr;

                if(c[i] == first){
                    other = curr[second];
                }
                else{
                    other = curr[first];
                }

                pr = other;

                //cout << pr << " " << cycle[0] << " cycle from the same" << endl;

                for(int x: cycle){
                    make_swap(x, pr);
                    pr = x;
                }

                make_swap(other, pr);
                continue;
            }

            cnt = 0;
            int pr = cycle[0], col = c[cycle[0]];

            for(int x: cycle){
                if(c[x] == col){
                    cnt++;
                }
            }

            cnt = (int)cycle.size() - cnt;

            //for(int x: cycle){
           //     cout << x << " ";
           // }
           // cout << endl;

            for(int j = 1; j < (int)cycle.size(); j++){
                int x = cycle[j];

                //cout << pr << " " << x << endl;

                if(c[x] != c[pr]){
                    if(cnt == 1){
                        pr = x;
                        break;
                    }

                    make_swap(x, pr);
                    pr = x;
                    cnt--;
                }
                else{
                    pr = x;
                }
            }

            int pr2 = pr;

            //cout << pr << " pr" << endl;

            for(int j = (int)cycle.size() - 1; j >= 0; j--){
                int x = cycle[j];

                if(c[x] == col && x != pr2){
                    make_swap(pr, x);
                    pr = x;
                }
            }
        }
    }

    cout << ans.size() << "\n";

    for(pair<int, int> p: ans){
        cout << p.first << " " << p.second << "\n";
    }

    return 0;
}
/*
7
2 5 3 7 1 6 4
3 2 2 3 3 2 3
*/
