/*
Alexander Hamilton
My name is Alexander Hamilton.
And there's a milion things I haven't done
but just you wait, just you wait
*/
#include <iostream>
#include <cstdint>
#include <vector>

uint32_t loopLen;

struct Vertex;

std::vector<Vertex*> loop;

struct Neno {
	Vertex *to;
	uint32_t c;

	Neno(Vertex *to = nullptr, uint32_t c = 0): to(to), c(c) {}
};

struct Vertex {
	std::vector<Neno> todorov;
	Neno par;
	Neno loopN;

	bool inLoop;
	bool vis;

	uint64_t maxDeep;
	uint64_t maxAns;

	Vertex(): inLoop(false), vis(false), maxDeep(0), maxAns(0) {}

	void find_loop() {
		vis = true;
		if (loopN.to->vis) {
			for (Vertex *v = loopN.to;v != this; v = v->loopN.to) {
				v->inLoop = true;
				loop.push_back(v);
			}
			inLoop = true;
			loop.push_back(this);
		} else {
			loopN.to->find_loop();
		}
	}
	void rm_loop_chld() {
		if (!inLoop) {
			return;
		}
		auto &v = loopN.to->todorov;
		for (auto it = v.begin();it != v.end();++it) {
			if (it->to == this) {
				v.erase(it);
				break;
			}
		}
		for (auto it = todorov.begin();it != todorov.end();++it) {
			if (it->to == loopN.to) {
				todorov.erase(it);
				break;
			}
		}
	}
	void build_tree() {
		for (auto it = todorov.begin();it != todorov.end();it++) {
			if (it->to == par.to) {
				todorov.erase(it);
				break;
			}
		}
		//CHOPIN
		for (const Neno &d : todorov) {
			d.to->par = {this, d.c};
			d.to->build_tree();
		}
	}
	void calc_tree_ans() {
		for (const Neno &d : todorov) {
			d.to->calc_tree_ans();
			uint64_t cur = d.to->maxDeep + d.c;
			maxAns = std::max(maxAns, maxDeep + cur);
			maxDeep = std::max(maxDeep, cur);
		}
	}
};

//chopin
std::vector<Vertex> graph;

void input() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	uint32_t n;
	std::cin >> n;

	std::vector<uint32_t> to(n);
	for (uint32_t &i : to) {
		std::cin >> i;
		i--;
	}

	graph.resize(n);
	for (uint32_t i = 0;i < n;i++) {
		uint32_t w;
		std::cin >> w;
		graph[i].loopN = {&graph[to[i]], w};
		graph[i].todorov.push_back({&graph[to[i]], w});
		graph[to[i]].todorov.push_back({&graph[i], w});
	}
}

void process_graph() {
	graph[0].find_loop();
	for (Vertex *v : loop) {
		v->rm_loop_chld();
	}
	for (Vertex *v : loop) {
		v->build_tree();
		v->calc_tree_ans();
	}
}

std::vector<uint64_t> vCost;
std::vector<uint64_t> eCost;
std::vector<uint64_t> eSum;
uint64_t loopSum;

void process_loop() {
	loopSum = 0;
	for (Vertex *v : loop) {
		vCost.push_back(v->maxDeep);
		eCost.push_back(v->loopN.c);
		loopSum += v->loopN.c;
	}
	for (uint32_t i = 0;i < loop.size();i++) {
		vCost.push_back(vCost[i]);
		eCost.push_back(eCost[i]);
	}
	eSum.push_back(0);
	for (uint32_t i = 0;i < eCost.size();i++) {
		eSum.push_back(eSum.back() + eCost[i]);
	}
}

uint64_t calc_ans() {
	uint64_t ans = 0;
	uint32_t rI = 0;
	for (uint32_t i = 0;i < loop.size();i++) {
		ans = std::max(ans, loop[i]->maxAns);
		while (
				(rI + 1 < i + loop.size()) &&
				((eSum[rI + 1] - eSum[i]) * 2 <= loopSum) 
		) {
			rI++;
		}
		uint64_t maxV = eSum[i];
		for (uint32_t j = i + 1;j <= rI;j++) {
			uint64_t curV = eSum[j] + vCost[j];
			maxV = std::max(maxV, curV);
		}
		ans = std::max(ans, maxV + vCost[i] - eSum[i]);
	}
	return ans;
}

int main() {
	input();
	//std::cerr << "hi" << std::endl;
	process_graph();
	//std::cerr << "hi" << std::endl;
	process_loop();
	std::cout << calc_ans() << "\n";
}
