/*
Alexander

Aarron Burr, sir

It's the middle of the night

Can we confer, sir?

Is it a legal mater?

Yes, and it's important to me

What do you need?

Burr, you're a better lawyer than me

Okay

I talk too much, I'm abrasive
You're incredible in court,
you're succint, persuasive.
My client needs strong defense,
you're the solution.

Who's your client?

The new U.S. Constitution?
*/

#include <iostream>
#include <cstdint>
#include <vector>
#include <utility>
#include <queue>
#include <cassert>

struct Book {
	uint32_t tI;
	uint32_t c;
};

std::vector<Book> books;

void input() { 
	std::cin.tie(nullptr);
	std::ios::sync_with_stdio(false);

	uint32_t n;
	std::cin >> n;
	books.resize(n);
	for (Book &b : books) {
		std::cin >> b.tI;
		b.tI--;
	}
	for (Book &b : books) {
		std::cin >> b.c;
		b.c--;
	}
}
std::vector<std::pair<uint32_t, uint32_t>> ans;
void do_swap(uint32_t i, uint32_t j) {
	std::swap(books[i], books[j]);
	ans.push_back({i + 1, j + 1});
}

struct Loop {
	uint32_t s;
	uint32_t len;
	std::vector<uint32_t> col; //first two cols;
	std::vector<uint32_t> colI; //first two cols;

	//eiher this is hetero, or both are mono
	void merge(Loop l) {
		//std::cerr << "merging " << s << " with " << l.s << "\n";
		for (uint32_t i = 0;i < col.size();i++) {
			if (col[i] != l.col[0]) {
				do_swap(colI[i], l.colI[0]);
				std::swap(colI[i], l.colI[0]);
				if (col.size() == 1) {
					col.push_back(l.col[0]);
					colI.push_back(l.colI[0]);
				}
			//	std::cerr << "success\n";
			//	for (uint32_t i = 0;i < books.size();i++) {
			//		std::cerr << "(" << books[i].tI << " " <<books[i].c << ") ";
			//	}
			//	std::cerr << "\n";
				len += l.len;
				return;
			}
		}

	}
};

struct MLoopSet {
	uint32_t col;
	std::vector<Loop> loops;
	uint32_t used;
};

std::vector<bool> vis;
std::vector<Loop> loops;

void build_loops() {
	vis = std::vector<bool>(books.size(), false);
	loops.clear();
	for (uint32_t i = 0;i < books.size();i++) {
		if (vis[i]) {
			continue;
		}
		Loop l;
		l.len = 1;
		l.s = i;
		l.col.push_back(books[i].c);
		l.colI.push_back(i);
		vis[i] = true;
		for (uint32_t j = books[i].tI;j != i;j = books[j].tI) {
			if (
				(l.col.size() == 1) &&
				(books[j].c != l.col.back())
			) {
				l.col.push_back(books[j].c);
				l.colI.push_back(j);
			}
			l.len++;
			vis[j] = true;
		}
		//std::cerr << "Loop " << i << " colCnt " << l.col.size() << "\n";
		loops.push_back(l);
	}
}

typedef std::pair<uint32_t, uint32_t> LLS;
void merge_loops() {
	std::vector<MLoopSet> lSets;
	std::vector<Loop> mLoops;
	Loop hLoop;

	lSets.resize(books.size());
	hLoop.s = books.size();

	for (uint32_t i = 0;i < loops.size();i++) {
		if (loops[i].col.size() > 1) {
			hLoop = loops[i];
		} else if (loops[i].len > 1) {
			uint32_t c = loops[i].col[0];
			//std::cerr << "loop c " << i << " " << c << "\n";
			lSets[c].col = c;
			lSets[c].used = 0;
			lSets[c].loops.push_back(loops[i]);
		} else if (mLoops.size() < 2) {
			if (mLoops.empty()) {
				mLoops.push_back(loops[i]);
			} else if (mLoops[0].col[0] != loops[i].col[0]) {
				mLoops.push_back(loops[i]);
			}
		}
	}
	std::priority_queue<LLS> maxSet;
	for (uint32_t i = 0;i < lSets.size();i++) {
		//std::cerr << "lssize " << i << " " << lSets[i].loops.size() << "\n";
		if (lSets[i].loops.size() > 0) {
			maxSet.push({lSets[i].loops.size(), i});
		}
	}

	while (maxSet.size() > 1) {
		uint32_t a = maxSet.top().second;
		maxSet.pop();
		uint32_t b = maxSet.top().second;
		maxSet.pop();
		
		Loop aL = lSets[a].loops[lSets[a].used];
		Loop bL = lSets[b].loops[lSets[b].used];

		aL.merge(bL);
		hLoop = aL;

		lSets[a].used++;
		lSets[b].used++;

		if (lSets[a].used < lSets[a].loops.size()) {
			maxSet.push({lSets[a].loops.size() - lSets[a].used, a});
		}
		if (lSets[b].used < lSets[b].loops.size()) {
			maxSet.push({lSets[b].loops.size() - lSets[b].used, b});
		}
	}
	if (maxSet.size() > 0) {
		uint32_t a = maxSet.top().second;
		if (hLoop.s == books.size()) {
			for (uint32_t i = 0;i < mLoops.size();i++) {
				if (mLoops[i].col[0] != a) {
					hLoop = mLoops[i];
				}
			}
		}
		for (uint32_t i = lSets[a].used;i < lSets[a].loops.size();i++) {
			hLoop.merge(lSets[a].loops[i]);
		}
	}
}

int main() {
	input();
	build_loops();
	merge_loops();
	build_loops();

	/*
	for (uint32_t i = 0;i < books.size();i++) {
		std::cerr << "(" << books[i].tI << " " <<books[i].c << ") ";
	}
	std::cerr << "\n";
	*/
	for (uint32_t i = 0;i < loops.size();i++) {
		assert((loops[i].len == 1) || (loops[i].col.size() > 1));
	}
}
