#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

const int32_t MAX_N = 50;

int32_t n, l;
int64_t a[MAX_N + 5], ans;

int64_t convert_to_int(const std::string &s) {
	int64_t res = 0;
	for(int32_t i = 0; i < l; i++) {
		if(s[l - 1 - i] == '1') {
			res += ((int64_t) 1 << (int64_t) i);
		}
	}
	return res;
}

void brute_force(int32_t ind, int64_t p, int64_t q) {
	if(ind == n) {
		int64_t aux = p;
		for(int32_t i = 0; i < l; i++) {
			if((q & ((int64_t) 1 << (int64_t) i)) != 0 && (aux & ((int64_t) 1 << (int64_t) i)) != 0) {
				aux ^= ((int64_t) 1 << (int64_t) i);
			}
		}

		ans = std::max(ans, aux);
		return;
	}

	brute_force(ind + 1, p, q);
	
	if((p & ((int64_t) 1 << (int64_t) l)) != 0 && (a[ind] & ((int64_t) 1 << (int64_t) l)) != 0) {
		return;
	}

	q |= (p & a[ind]);
	p ^= a[ind];
	
	brute_force(ind + 1, p, q);
}

void print_ans() {
	std::string res = "";
	for(int32_t i = l - 1; i >= 0; i--) {
		if((ans & ((int64_t) 1 << (int64_t) i)) != 0) {
			res += '1';
		}
		else {
			res += '0';
		}
	}

	std::cout << res << '\n';
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> l;
	for(int32_t i = 0; i < n; i++) {
		std::string s;
		std::cin >> s;

		a[i] = convert_to_int(s);
	}

	std::sort(a, a + n);

	int64_t p = 0, q = 0;
	brute_force(0, p, q);

	print_ans();
}
