#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
using namespace std;

#define NMax 100000

struct node
{
    int v,w;
    node() {};
    node(int a,int b)
    {
        v=a,w=b;
    }
};

int n;
long long maxdist[NMax+5],ans[NMax+5],maxans;
int arr[NMax+5],w[NMax+5],cycle[NMax+5],cur,way[NMax+5],cnt;
int weights[1005][1005],tmp[NMax+5];
bool used[NMax+5],fl,incycle[NMax+5],loop;
vector<node> nb[NMax+5];

void dfs_cycle(int v,int prev)
{
    if(fl==0)
    {

        way[cur++]=v;

        for(int i=0; i<nb[v].size(); i++)
        {
            if(fl==0&&nb[v][i].v==prev)
                continue;
            else if(fl==0&&nb[v][i].v!=prev&&used[nb[v][i].v]==1)
            {
                cycle[cnt++]=nb[v][i].v;
                for(int j=cur-1; way[j]!=nb[v][i].v; j--)
                    cycle[cnt++]=way[j];
                cycle[cnt++]=nb[v][i].v;
                fl=1;
            }
            else if(fl==0)
            {
                used[v]=1;
                dfs_cycle(nb[v][i].v,v);
                cur--;
            }
        }
    }
}

long long dfs_calc(int v)
{
    used[v]=1;
    long long best1=0,best2=0;

    for(int i=0; i<nb[v].size(); i++)
    {
        if(used[nb[v][i].v]||incycle[nb[v][i].v])
            continue;

        long long x=dfs_calc(nb[v][i].v);
        if(x+nb[v][i].w>best1)
        {
            best2=best1;
            best1=x+nb[v][i].w;
        }
        else if(x+nb[v][i].w>best2)
            best2=x+nb[v][i].w;
    }

    ans[v]=best1+best2;

    return maxdist[v]=best1;
}

int main()
{
    scanf("%d",&n);

    for(int i=0; i<n; i++)
        scanf("%d",&arr[i]);

    for(int i=0; i<n; i++)
    {
        scanf("%d",&w[i]);

        if(arr[i]!=i+1)
        {
            nb[i+1].push_back(node(arr[i],w[i]));
            nb[arr[i]].push_back(node(i+1,w[i]));
        }
        else
            loop=1;
    }

    if(loop==0)
    {
        for(int i=0;i<n;i++)
            weights[i+1][arr[i]]=w[i],
            weights[arr[i]][i+1]=w[i];

        dfs_cycle(1,0);

        for(int i=1; i<=n; i++)
            used[i]=0;
        for(int i=1; i<cnt; i++)
            used[cycle[i]]=1,incycle[cycle[i]]=1;
        for(int i=1; i<cnt; i++)
            dfs_calc(cycle[i]);

        for(int i=1; i<cnt; i++)
            tmp[i]=tmp[i-1]+weights[cycle[i-1]][cycle[i]];

        for(int i=0; i<cnt-1; i++)
        {
            for(int j=i+1; j<cnt-1; j++)
            {
                if((tmp[j]-tmp[i])*2<=tmp[cnt-1])
                    maxans=max(maxdist[cycle[i]]+maxdist[cycle[j]]+tmp[j]-tmp[i],maxans);
                else
                    maxans=max(maxdist[cycle[i]]+maxdist[cycle[j]]+tmp[cnt-1]-tmp[j]+tmp[i],maxans);
            }
        }

        printf("%lld\n",maxans);
    }

    else if(loop==1)
    {
        dfs_calc(1);

        for(int i=1; i<=n; i++)
            if(ans[i]>maxans)
                maxans=ans[i];

        printf("%lld\n",maxans);
    }

    return 0;
}

/**
8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8
*/
