#include <bits/stdc++.h>
using namespace std;
const int maxN=1e5+2;
long long INF=1e15;
int n;
long long ans;
struct node{
    int v;
    long long tg;
    node(){}
    node(int v,long long tg): v(v), tg(tg) {}
};
vector<node> graph[maxN];
int e[maxN],used[maxN];
long long dist[maxN];
void dfs(int s,long long d)
{
    dist[s]=min(dist[s],d);
    used[s]=1;
    for(int i=0;i<graph[s].size();i++)
    {
        if(!used[graph[s][i].v])
        {
            dfs(graph[s][i].v,d+graph[s][i].tg);
            used[graph[s][i].v]=0;
        }
    }
}
int main()
{
    int i,j,w;
    cin>>n;
    for(i=1;i<=n;i++)
    {
        cin>>e[i];
    }
    for(i=1;i<=n;i++)
    {
        cin>>w;
        graph[i].push_back(node(e[i],w));
        graph[e[i]].push_back(node(i,w));
    }
    for(i=1;i<=n;i++)
    {
        for(j=1;j<=n;j++)
        {
            dist[j]=INF;
            used[j]=0;
        }
        dfs(i,0);
        for(j=1;j<=n;j++)
        {
            ans=max(ans,dist[j]);
        }
    }
    cout<<ans<<endl;
}
/**
8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8
*/
