#include<iostream>
using namespace std;

const int maxn = 50;
unsigned long long keys[maxn];
int n, l;

bool cmp(unsigned long long a, unsigned long long b)/// a > b
{
    unsigned long long a1 = a & (~b);
    unsigned long long b1 = b & (~a);
    return a1 > b1;
}

unsigned long long best = 0;

void print(unsigned long long a)
{
    for(int i = l - 1; i >= 0; i --)
    {
        //cout << i << endl;
        if(((1ll<<i)&a) != 0)  cout << 1;
        else    cout << 0;
    }
}

void fnd(int i, unsigned long long curr, unsigned long long burnt)
{
    /*cout << i << " ";
    print(curr);
    cout << " ";
    print(burnt);
    cout << endl;*/
    if(cmp(curr, best))
    {
        best = curr;
    }
    if(cmp(best, ~burnt))  return;


    if(i >= n)  return;

    fnd(i + 1, curr, burnt);

    burnt |= curr & keys[i];

    /*cout << "| " << keys[i] << " ";
    print(keys[i]);
    cout << endl;*/
    curr |= keys[i];
    curr &= ~burnt;

    fnd(i + 1, curr, burnt);
}

int main()
{
    cin >> n >> l;
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < l; j ++)
        {
            char c;
            cin >> c;
            keys[i] <<= 1;
            if(c == '1')
            {
                keys[i] ^= 1;
            }
        }
        //cout << keys[i] << endl;
    }
    fnd(0,0,0);
    print(best);
}
/**
3 5
01101
10110
01011
*/
/**
2 5
11101
11111
*/
