#include<iostream>
#include<vector>
#include<queue>
#include<random>
#include<ctime>
#include<stack>
using namespace std;

const long long maxn = 1000000;
long long n;

pair<long long,long long> e[2 * maxn];
vector<long long> v[maxn];
bool visited[maxn];
vector<int> leaf;

vector<int> cycle;

void fnd_cycle()
{

}

int main()
{
    srand(123);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(long long i = 0; i < n; i ++)
    {
        long long j;
        cin >> j;
        j --;
        if(j == i)  continue;
        e[2 * i].first = j;
        e[2 * i + 1].first = i;
        v[i].push_back(2 * i);
        v[j].push_back(2 * i + 1);
    }
    long long max_edge = 0;
    for(long long i = 0; i < n; i ++)
    {
        long long w;
        cin >> w;
        max_edge = max(max_edge, w);
        e[2 * i].second = w;
        e[2 * i + 1].second = w;
    }

    for(int i = 0; i < n; i ++)
    {
        if(v[i].size() == 1)
        {
            leaf.push_back(i);
        }
    }

    long long max_dist = 0;
    long long farthest = 0;
    long long ans = 0;

    while(1)
    {
        if(leaf.size() == 0)
        {
            farthest = rand() % n;
        } else {
            farthest = leaf[rand() % leaf.size()];
        }
        for(long long _ = 0; _ < 2; _ ++)
        {
            priority_queue<pair<long long,long long> > q;
            q.push({0,farthest});
            max_dist = 0;
            for(long long i = 0; i < n; i ++) visited[i] = 0;

            while(!q.empty())
            {
                pair<long long,long long> t = q.top();
                q.pop();
                if(visited[t.second])   continue;
                visited[t.second] = true;
                if(-t.first > max_dist)
                {
                    max_dist = - t.first;
                    farthest = t.second;
                }
                //cout << t.second + 1<< endl;
                for(long long k = 0; k < v[t.second].size(); k ++)
                {
                    long long i = v[t.second][k];
                    if(!visited[e[i].first])
                    {
                        q.push({t.first - e[i].second, e[i].first});
                    }
                }
            }
            ans = max(ans, max_dist);
            //cout << "~" << max_dist  << endl;
        }
        if(1. * clock() / CLOCKS_PER_SEC >= 0.35)  break;
    }
    cout << ans;
}
/**
8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8
*/
