#include<iostream>
#include<algorithm>
#include<ctime>
using namespace std;

const int maxn = 50;
unsigned long long keys[maxn];
int n, l;

inline bool cmp(unsigned long long a, unsigned long long b)/// a > b
{
    return a > b;
}

unsigned long long best = 0;

void print(unsigned long long a)
{
    for(int i = l - 1; i >= 0; i --)
    {
        //cout << i << endl;
        if(((1ll<<i)&a) != 0)  cout << 1;
        else    cout << 0;
    }
}

void fnd(int i, unsigned long long curr, unsigned long long burnt)
{
    if(1. * clock() / CLOCKS_PER_SEC > 1.4) return;
    /*cout << i << " ";
    print(curr);
    cout << " ";
    print(burnt);
    cout << endl;*/
    if(cmp(curr, best))
    {
        best = curr;
    }
    if(cmp(best, ~burnt))  return;


    if(i >= n)  return;

    fnd(i + 1, curr, burnt);
    if(keys[i] > ~curr) return;

    burnt |= curr & keys[i];

    /*cout << "| " << keys[i] << " ";
    print(keys[i]);
    cout << endl;*/
    curr |= keys[i];
    curr &= ~burnt;

    fnd(i + 1, curr, burnt);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> l;
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < l; j ++)
        {
            char c;
            cin >> c;
            keys[i] <<= 1;
            if(c == '1')
            {
                keys[i] ^= 1;
            }
        }
        //cout << keys[i] << endl;
    }
    sort(keys, keys + n);
    /*for(int i = 0; i < n; i ++)
    {
        print(keys[i]);
        cout << endl;
    }*/
    fnd(0,0,0);
    print(best);
}
/**
3 5
01101
10110
01011
*/
/**
2 5
11101
11111
*/
/**
10 20
00010111011100101010
11110001010110011110
00101010100100000100
11000000111011101000
01100101011001100100
11010010110010000100
01111111011000010001
00001010111010011111
11100011101000011011
10001000011001001111
*/
