#include <bits/stdc++.h>
using namespace std;
int n;
bool dali = 0;
int p [1000006];
vector <pair <int, int> > g [1000006];
long long ans = 0ll;
bool used [1000006];
long long dfs (int a){
	used [a] = 1;
	pair <long long, long long> x;
	for (auto i : g [a]){
		if (used [i.first]) continue;
		long long x1 = dfs (i.first);
		x1 += i.second;
		if (x1 >x.first){
			x.second = x.first;
			x.first = x1;
		}
		else if (x1 > x.second){
			x.second = x1;
		}
	}
	ans = max (ans, x.first + x.second);
	return x.first;
}
long long path [1024][1024];
void dejkstra (int a){
	priority_queue <pair <long long, int> > pq;
	pq.push ({0, a});
	while (!pq.empty ()){
		auto P = pq.top ();
		pq.pop ();
		if (used [P.second]) continue;
		path [a][P.second] = -P.first;
		used [P.second] = 1;
		for (auto i : g [P.second]){
			if (used [i.first]) continue;
			pq.push ({P.first - i.second, i.first});
		}
	}
}
int main (){

	ios::sync_with_stdio (false);
	cin.tie (0);

	cin >> n;
	for (int i = 1; i <= n; i ++){
		cin >> p [i];
		if (p [i] == i) dali = 1;
	}
	for (int i = 1; i <= n; i ++){
		int w;
		cin >> w;
		g [i].push_back ({p [i], w});
		g [p [i]].push_back ({i, w});
	}
	if (dali){
		dfs (1);
		cout << ans << '\n';
		return 0;
	}

	for (int i = 1; i <= n; i ++){
		for (int j = 1; j <= n; j ++) used [j] = 0;
		dejkstra (i);
		for (int j = 1; j <= n; j ++) ans = max (ans, path [i][j]);
	}
	cout << ans << '\n';

	return 0;
}
