#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1000003
using namespace std;
typedef long long ll;
typedef long double ld;
int n;
vector <pair <int, int> > adj[MAXN];
pair <int, int> nb[MAXN];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> nb[i].first;
        for (int i = 1; i <= n; i++)
            cin >> nb[i].second;
}
ll depth[MAXN], longest[MAXN];
void dfs(int ver, int par)
{
    depth[ver] = longest[ver] = 0;
    ll max1 = 0, max2 = 0;
    for (auto i: adj[ver])
        if (i.first != par)
    {
        dfs(i.first, ver);
        if (depth[i.first] + i.second > max1)
        {
            max2 = max1;
            max1 = depth[i.first] + i.second;
        }
        else
            if (depth[i.first] + i.second == max1)
            max2 = max1;
            longest[ver] = max(longest[ver], longest[i.first]);
    }
    longest[ver] = max(longest[ver], max1 + max2);
    depth[ver] = max1;
}
void solve()
{
    bool is = false;
    for (int i = 1; i <= n; i++)
    {
        if (nb[i].first == i)
            is = true;
        else
        {
            adj[i].push_back(nb[i]);
            adj[nb[i].first].push_back({i, nb[i].second});
        }
    }
    if (is)
    {
        dfs(1, -1);
        cout << longest[1] << endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
