#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1000003
using namespace std;
typedef long long ll;
typedef long double ld;
ll n;
vector <pair <ll, ll> > adj[MAXN];
pair <ll, ll> nb[MAXN];
void read()
{
    cin >> n;
    for (ll i = 1; i <= n; i++)
        cin >> nb[i].first;
        for (ll i = 1; i <= n; i++)
            cin >> nb[i].second;
}
ll depth[MAXN];
ll ans = -1;
void dfs(ll ver, ll par)
{
    depth[ver] = 0;
    ll max1 = 0, max2 = 0;
    for (auto i: adj[ver])
        if (i.first != par)
    {
        dfs(i.first, ver);
        if (depth[i.first] + i.second > max1)
        {
            max2 = max1;
            max1 = depth[i.first] + i.second;
        }
        else
            if (depth[i.first] + i.second == max1)
            max2 = max1;
    }
    ll curr = max1 + max2;
    if (nb[ver].first == ver)
        curr += nb[ver].second;
    ans = max(ans, curr);
    depth[ver] = max1;
}
void solve()
{
    bool is = false;
    for (ll i = 1; i <= n; i++)
    {
        if (nb[i].first == i)
            is = true;
        else
        {
            adj[i].push_back(nb[i]);
            adj[nb[i].first].push_back({i, nb[i].second});
        }
    }
    if (is)
    {
        dfs(1, -1);
        cout << ans << endl;
    }
    else
    {

    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
