#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1000003
using namespace std;
typedef long long ll;
typedef long double ld;
int n;
pair <int, int> nb[MAXN];
vector <pair <int, int> > adj[MAXN];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> nb[i].first;
    for (int i = 1; i <= n; i++)
        cin >> nb[i].second;
}
int depth[MAXN], par[MAXN];
int first, second, cost;
void dfs(int ver)
{
    for (auto i: adj[ver])
    {
        if (depth[i.first] == -1)
        {
            depth[i.first] = depth[ver] + 1;
            par[i.first] = ver;
            dfs(i.first);
        }
        else if (depth[i.first] != depth[ver] - 1)
        {
            first = ver;
            second = i.first;
            cost = i.second;
        }
    }
}
map <pair <int, int>, bool> banned;
void bann(int a, int b)
{
    banned[ {a, b}] = banned[ {b, a}] = true;
}
void unbann(int a, int b)
{
    banned[ {a, b}] = banned[ {b, a}] = false;
}
ll ans = 0;
ll longest[MAXN];
bool used[MAXN];
void dfs1(int ver)
{
    longest[ver] = 0;
    ll max1 = 0, max2 = 0;
    used[ver] = true;
    for (auto i: adj[ver])
        if (!used[i.first] && !banned[ {ver, i.first}])
        {
            dfs1(i.first);
            if (i.second + longest[i.first] > max1)
            {
                max2 = max1;
                max1 = i.second + longest[i.first];
            }
            else if (i.second + longest[i.first] > max2)
                max2 = i.second + longest[i.first];
        }
    ans = max(ans, max1 + max2);
    longest[ver] = max1;
}
void solve()
{
    bool is = false;
    for (int i = 1; i <= n; i++)
    {
        if (nb[i].first == i)
            is = true;
        else
        {
            adj[i].push_back(nb[i]);
            adj[nb[i].first].push_back({i, nb[i].second});
        }
    }
    if (is)
    {
        for (;;)
        {

        }
        return;
    }
    memset(depth, -1, sizeof(depth));
    memset(par, -1, sizeof(par));
    depth[1] = 1;
    dfs(1);
    bann(first, second);
    int curr = second;
    while (curr != first)
    {
        bann(curr, par[curr]);
        curr = par[curr];
    }
    for (int i = 1; i <= n; i++)
        if (!used[i])
        dfs1(i);
    cout << ans << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
