#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1000003
#define INF 1000000000000000
using namespace std;
typedef long long ll;
typedef long double ld;
int n;
vector <pair <int, ll> > adj[MAXN];
pair <int, ll> nb[MAXN];
void read()
{
    cin >> n;
    for (ll i = 1; i <= n; i++)
        cin >> nb[i].first;
    for (ll i = 1; i <= n; i++)
        cin >> nb[i].second;
}
ll depth[MAXN];
ll ans = 0;
void dfs(int ver, int par)
{
    depth[ver] = 0;
    ll max1 = 0, max2 = 0;
    for (auto i: adj[ver])
        if (i.first != par)
        {
            dfs(i.first, ver);
            if (i.second + depth[i.first] > max1)
            {
                max2 = max1;
                max1 = i.second + depth[i.first];
            }
            else if (i.second + depth[i.first] > max2)
                max2 = i.second + depth[i.first];
        }
    ans = max(ans, max1 + max2);
    depth[ver] = max1;
}
int par[MAXN];
bool used[MAXN];
int first, second;
void dfs1(int ver)
{
    used[ver] = true;
    for (auto i: adj[ver])
    {
        if (!used[i.first])
        {
            par[i.first] = ver;
            dfs1(i.first);
        }
        else if (i.first != par[ver])
        {
            first = i.first;
            second = ver;
        }
    }
}
void dfs2(int ver)
{
    depth[ver] = 0;
    ll max1 = 0, max2 = 0;
    for (auto i: adj[ver])
        if (i.first != par[ver] && !used[i.first])
        {
            dfs(i.first, ver);
            if (i.second + depth[i.first] > max1)
            {
                max2 = max1;
                max1 = i.second + depth[i.first];
            }
            else if (i.second + depth[i.first] > max2)
                max2 = i.second + depth[i.first];
        }
    ans = max(ans, max1 + max2);
    depth[ver] = max1;
}
ll prefix[MAXN];
void solve()
{
    bool is = false;
    for (ll i = 1; i <= n; i++)
    {
        if (nb[i].first == i)
            is = true;
        else
        {
            adj[i].push_back({nb[i].first, nb[i].second});
            adj[nb[i].first].push_back({i, nb[i].second});
        }
    }
    if (is)
    {
        dfs(1, -1);
        cout << ans << endl;
    }
    else
    {
        dfs1(1);
        vector <int> cycle;
        int curr = first;
        while (curr != second)
        {
            cycle.push_back(curr);
            curr = par[curr];
        }
        cycle.push_back(curr);
        memset(used, false, sizeof(used));
        for (auto i: cycle)
            used[i] = true;
        for (auto i: cycle)
            dfs2(i);

    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
