#include<iostream>
#include<queue>
#include<vector>
using namespace std;
struct edge
{
    long to,val,prev;
};
int n;
vector<edge> E;
int last[1000002];
int p[1000008];
int d_res;
int d_node;
void dijkstra(int src)
{
    vector<bool> visited(n+1,0);
    priority_queue<pair<int,int>> pq;
    pq.push({0,src});
    for(int i=1;i<=n;i++)
    {

        while(visited[pq.top().second])
        {
            pq.pop();
        }
        auto cur=pq.top();
        //cout<<"pick"<<cur.second<<" "<<-cur.first<<endl;
        pq.pop();
        visited[cur.second]=1;
        d_res=-cur.first;
        d_node=cur.second;
        for(int Q=last[cur.second];Q!=-1;Q=E[Q].prev)
        {
            if(!visited[E[Q].to])
            {
                pq.push({-(E[Q].val+d_res),E[Q].to});
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n;

    int curr;
    for(int i=1;i<=n;i++)
    {
        last[i]=-1;
        cin>>p[i];
    }
    int q=0;
    for(int i=1;i<=n;i++)
    {
        cin>>curr;
        E.push_back({p[i],curr,last[i]});
        last[i]=q;
        q++;
        E.push_back({i,curr,last[p[i]]});
        last[p[i]]=q;
        q++;
    }
    dijkstra(1);
  //  cout<<d_node<<":"<<d_res<<endl;
    dijkstra(d_node);
    cout<<d_res<<endl;
    return 0;
}
