#include<iostream>
#include<queue>
#include<vector>
#include<random>
using namespace std;
struct edge
{
    long long to,val,prev;
};
long long n;
vector<edge> E;
long long last[1000002];
long long p[1000008];
long long d_res;
long long d_node;
void dijkstra(long long src)
{
    vector<bool> visited(n+1,0);
    priority_queue<pair<long long,long long>> pq;
    pq.push({0,src});
    for(long long i=1;i<=n;i++)
    {

        while(visited[pq.top().second])
        {
            pq.pop();
        }
        auto cur=pq.top();
        //cout<<"pick"<<cur.second<<" "<<-cur.first<<endl;
        pq.pop();
        visited[cur.second]=1;
        d_res=-cur.first;
        d_node=cur.second;
        for(long long Q=last[cur.second];Q!=-1;Q=E[Q].prev)
        {
            if(!visited[E[Q].to])
            {
                pq.push({-(E[Q].val+d_res),E[Q].to});
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n;

    long long curr;
    for(long long i=1;i<=n;i++)
    {
        last[i]=-1;
        cin>>p[i];
    }
    long long q=0;
    for(long long i=1;i<=n;i++)
    {
        cin>>curr;
        E.push_back({p[i],curr,last[i]});
        last[i]=q;
        q++;
        E.push_back({i,curr,last[p[i]]});
        last[p[i]]=q;
        q++;
    }
    long long  maxx=0;
    for(int i=0;i<1000;i++)
    {
        dijkstra((rand()%n)+1);
    //cout<<d_node<<":"<<d_res<<endl;
        dijkstra(d_node);
        maxx=max(d_res,maxx);

    }
    cout<<maxx;
    return 0;
}
/*
8
2 4 4 4 1 5 5 7
1 2 3 2 5 6 7 8*/
