#include<iostream>
#include<queue>
#include<vector>
#include<random>
using namespace std;
struct edge
{
    long long to,val,prev;
};
long long n;
vector<edge> E;
long long last[1000002];
long long p[1000008];
long long val[1000008];
long long d_res;
long long d_node;
void dijkstra(long long src)
{
    vector<bool> visited(n+1,0);
    priority_queue<pair<long long,long long>> pq;
    pq.push({0,src});
    for(long long i=1;i<=n;i++)
    {

        while(visited[pq.top().second])
        {
            pq.pop();
        }
        auto cur=pq.top();
        //cout<<"pick"<<cur.second<<" "<<-cur.first<<endl;
        pq.pop();
        visited[cur.second]=1;
        d_res=-cur.first;
        d_node=cur.second;
        for(long long Q=last[cur.second];Q!=-1;Q=E[Q].prev)
        {
            if(!visited[E[Q].to])
            {
                pq.push({-(E[Q].val+d_res),E[Q].to});
            }
        }
    }
}
int main()
{
    mt19937 rng(14685793);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n;
    bool t1=0;
    long long curr;
    for(long long i=1;i<=n;i++)
    {
        last[i]=-1;
        cin>>p[i];
        if(p[i]==i)
        {
            t1=1;
        }
    }
    long long q=0;
    for(long long i=1;i<=n;i++)
    {
        cin>>curr;
        val[i]++;
        val[p[i]]++;
        E.push_back({p[i],curr,last[i]});
        last[i]=q;
        q++;
        E.push_back({i,curr,last[p[i]]});
        last[p[i]]=q;
        q++;
    }
    if(t1)
    {
dijkstra(1);
    //cout<<d_node<<":"<<d_res<<endl;
        dijkstra(d_node);
        cout<<d_res<<endl;
        return 0;
    }
    long long  maxx=0;
    for(int i=1;i<n;i++)
    {
        if(val[i]==2)
        {
        dijkstra(i);
    //cout<<d_node<<":"<<d_res<<endl;
        dijkstra(d_node);
       cout<<d_res<<endl;
       return 0;
        }
    }
    dijkstra(n);
    //cout<<d_node<<":"<<d_res<<endl;
    dijkstra(d_node);
    cout<<d_res<<endl;
    return 0;
}
/*
8
2 4 4 4 1 5 5 7
1 2 3 2 5 6 7 8*/
