#include <iostream>
#include <vector>
#include <queue>

using namespace std;

struct Road
{
    int to;
    int w;

    Road() {}

    Road(int to, int w)
    {
        this->to = to;
        this->w = w;
    }
};

vector<Road> A[1000000];
int level[1000000];
int len[1000000];

int nodes, res, last;

inline void solve (int n)
{
    last = n;

    queue <pair <int, int> > q;
    q.push({n, -1});

    while (!q.empty())
    {
        pair<int, int> curr = q.front();
        q.pop();

        //cout << curr.first << '\n';
        //cin >> n;

        if (level[curr.first] > nodes or (level[curr.first] == nodes and len[curr.first] < res))
        {
            nodes = level[curr.first];
            res = len[curr.first];
            last = curr.first;
        }

        for (int i = 0; i < A[curr.first].size(); ++i)
        {
            if (A[curr.first][i].to != curr.second and
                (level[curr.first] + 1 > level[A[curr.first][i].to] or
                    (level[curr.first] + 1 == level[A[curr.first][i].to] and len[curr.first] + A[curr.first][i].w < len[A[curr.first][i].to])))
            {
                //cout << curr.first << "->" << A[curr.first][i].to << ' ' << level[A[curr.first][i].to] << ' ' << level[curr.first] + 1 <<
                        ' ' << len[A[curr.first][i].to] << ' ' << len[curr.first] + A[curr.first][i].w << '\n';

                level[A[curr.first][i].to] = level[curr.first] + 1;
                len[A[curr.first][i].to] = len[curr.first] + A[curr.first][i].w;

                q.push({A[curr.first][i].to, curr.first});
            }
        }
    }
}

int main  ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;

    for (int i = 0; i < n; ++i)
    {
        Road curr;
        cin >> curr.to;
        --curr.to;

        A[i].push_back(curr);
    }

    for (int i = 0; i < n; ++i)
    {
        cin >> A[i][0].w;

        A[A[i][0].to].push_back(Road(i, A[i][0].w));
    }

    solve(0);
    solve(last);

    cout << len << '\n';
    return 0;
}
