#include <iostream>
#include <vector>

using namespace std;

struct Book
{
    int pos;
    int color;
};

int main  ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;

    vector <Book> A(n);

    for (int i = 0; i < n; ++i)
    {
        cin >> A[i].pos;
        --A[i].pos;
    }

    for (int i = 0; i < n; ++i)
    {
        cin >> A[i].color;
    }

    int res = 0;
    vector <pair <int, int> > swaps;

    while (true)
    {
        for (int i = 0; i < n; ++i)
        {
            if(i != A[i].pos)
            {
                if (A[A[i].pos].color != A[i].color)
                {
                    ++res;
                    swaps.push_back({i + 1, A[i].pos + 1});

                    swap(A[i], A[A[i].pos]);

                    --i;

                    /*for (int iii = 0; iii < n; ++iii)
                    {
                        cout << A[iii].pos + 1 << '-' << A[iii].color << ' ';
                    }
                    cout << '\n';*/
                }
                else
                {
                    int pos;
                    for (int j = 0; j < n; ++j)
                    {
                        if (A[j].color != A[i].color)
                        {
                            pos = j;
                            break;
                        }
                    }
                    res += 3;

                    int f = i, s = A[i].pos;

                    swap(A[s], A[pos]);
                    swaps.push_back(make_pair(s + 1, pos + 1));

                    swap(A[f], A[s]);
                    swaps.push_back(make_pair(f + 1, s + 1));

                    swap(A[f], A[pos]);
                    swaps.push_back(make_pair(f + 1, pos + 1));

                }
            }
        }

        bool sorted = true;
        for (int i = 0; i < n; ++i)
        {
            if (A[i].pos != i)
            {
                sorted = false;
                break;
            }
        }

        if (sorted)
        {
            break;
        }
    }

    /*for (int i = 0; i < n; ++i)
    {
        cout << A[i].pos + 1 << '-' << A[i].color << ' ';
    }
    cout << '\n';*/

    cout << res << '\n';
    for (int i = 0; i < res; ++i)
    {
        cout << swaps[i].first << ' ' << swaps[i].second << '\n';
    }

    return 0;
}
