#include <iostream>
#include <vector>

using namespace std;

struct Book
{
    int pos;
    int color;
};

int main  ()
{
    int n;
    cin >> n;

    vector <Book> A(n);

    for (int i = 0; i < n; ++i)
    {
        cin >> A[i].pos;
        --A[i].pos;
    }

    for (int i = 0; i < n; ++i)
    {
        cin >> A[i].color;
    }

    int res = 0;
    vector <pair <int, int> > swaps;

    bool sorted = false;
    while (!sorted)
    {
        sorted = true;

        for (int i = 0; i < n; ++i)
        {
            if(i != A[i].pos)
            {
                if (A[A[i].pos].color != A[i].color)
                {
                    ++res;
                    swaps.push_back({A[i].pos + 1, i + 1});

                    swap(A[i], A[A[i].pos]);
                }
                else
                {
                    sorted = false;
                }
            }
        }
    }


    cout << res << '\n';
    for (int i = 0; i < res; ++i)
    {
        cout << swaps[i].first << ' ' << swaps[i].second << '\n';
    }

    return 0;
}
