#include<iostream>
#include<vector>
#include<queue>
#include<algorithm>
using namespace std;
int n;
int p[1000005],w[1000005];
vector<pair<int,int> > v[100005];
long long ans;



long long hook,wh;
vector<pair<long long,long long> > nextV[1000005];
bool used[1000005];

void makeTree (long long pos)
{
    used[pos]=true;
    for (long long i=0; i<v[pos].size(); i++)
    {
        if (used[v[pos][i].first])
            continue;
        nextV[pos].push_back(v[pos][i]);
        makeTree(v[pos][i].first);
    }
}
bool cmp (long long x, long long y)
{
    return x>y;
}
long long solve (long long pos)
{
    if (nextV[pos].size()==0)
        return 0;
    vector<long long> z;
    for (long long i=0; i<nextV[pos].size(); i++)
        z.push_back((long long)solve(nextV[pos][i].first)+nextV[pos][i].second);

    if (z.size()==1)
    {
        ans=max(ans,z[0]);
        return z[0];
    }
    sort(z.begin(),z.end(),cmp);
    ans=max(ans,z[0]+z[1]);
    return z[0];
}




long long d[1000005];
void dijkstra (int pos)
{
    priority_queue<pair<long long, int> > q;
    q.push(make_pair(0,pos));
    for (int i=1; i<=n; i++)
        d[i]=9999999999999ll;
    d[pos]=0;
    while (!q.empty())
    {
        int num;
        long long t;
        num=q.top().second;
        t=-q.top().first;
        q.pop();
        if (d[num]<t)
            continue;



        for (int i=0; i<v[num].size(); i++)
        {
            int num2=v[num][i].first;
            if (d[num2]>d[num]+v[num][i].second)
            {
                long long y=d[num]+v[num][i].second;
                d[num2]=y;
                q.push(make_pair(-y,num2));
            }
        }
    }
//
//    cout<<'\n';
//    cout<<pos<<'\n';
//    for (int i=1; i<=n; i++)
//        cout<<d[i]<<' ';
//    cout<<'\n';


    for (int i=1; i<=n; i++)
        ans=max(ans,d[i]);
}

int main()
{
    cin>>n;
    for (long long i=0; i<n; i++)
        cin>>p[i];
    for (long long i=0; i<n; i++)
        cin>>w[i];

    for (long long i=0; i<n; i++)
    {
        long long x=i+1,y=p[i];
        if (x==y)
        {
            hook=x;
            wh=w[i];
            continue;
        }
        v[x].push_back(make_pair(y,w[i]));
        v[y].push_back(make_pair(x,w[i]));
    }

    if (hook!=0)
    {
        makeTree(1);
        solve(1);
    }

    else
        for (int i=1; i<=n; i++)
            dijkstra(i);

    cout<<ans<<'\n';
}
