#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cassert>

using namespace std;

vector<vector<pair<uint32_t, uint64_t>>> ss;

uint64_t is_tree=0;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t n;
    cin>>n;
    ss.resize(n);
    vector<uint32_t> tmp(ss.size());
    for(uint32_t i=0; i<ss.size(); i++)
    {
        cin>>tmp[i];
        tmp[i]--;
    }
    for(uint32_t i=0; i<ss.size(); i++)
    {
        uint32_t x;
        cin>>x;
        if(tmp[i]!=i)
        {
            ss[i].push_back(make_pair(tmp[i], x));
            ss[tmp[i]].push_back(make_pair(i, x));
        }
        else
        {
            is_tree++;
        }
    }
    assert(is_tree<=1);
}

int main()
{
    init();
    cout<<is_tree<<endl;


    return 0;
}
