#include <cstdint>
#include <cstdlib>
#include <iostream>
#include <cstdint>
#include <vector>

using namespace std;

vector<uint32_t> books;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    uint32_t n;
    cin>>n;
    books.resize(n);
    for(uint32_t i=0; i<books.size(); i++)
    {
        cin>>books[i];
        books[i]--;
    }
}

vector<pair<uint32_t, uint32_t>> res;

void solve()
{
    res.reserve(books.size()<<2);
    bool is_ok=true;
    while(true)
    {
        is_ok=true;
        for(uint32_t i=0; i<books.size(); i++)
        {
            if(books[i]!=i)
            {
                is_ok=false;
                res.push_back(make_pair(i+1, books[i]+1));//cout<<i+1<<' '<<books[i]+1<<'\n';
                swap(books[i], books[books[i]]);
            }
        }
        if(is_ok==true)
        {
            return;
        }
    }
}

void show_res()
{
    cout<<res.size()<<'\n';
    for(auto x:res)
    {
        cout<<x.first<<' '<<x.second<<'\n';
    }
}

int main()
{
    init();
    solve();
    show_res();

    return 0;
}
