#include<bits/stdc++.h>
using namespace std;
const int nmax=1e6+42;
int n;
int to[nmax],cost[nmax];
bool blocked[nmax];

long long/*longest*/ ret;
int where=0;

int seen[nmax];
pair<int/*to*/,int/*cost*/> EDGE[nmax];

void dfs(int node,int parent,long long c)
{
    if(blocked[node])return;
    if(c>ret)
    {
        ret=c;
        where=node;
    }

    if(to[node]!=parent&&to[node]!=node)dfs(to[node],node,c+cost[node]);

    for(int i=seen[node];i<seen[node+1];i++)
        if(EDGE[i].first!=parent)dfs(EDGE[i].first,node,c+EDGE[i].second);
}
int par[nmax];

int beg,en;

void dfs_cycle(int node,int parent)
{
    //cout<<"dfs_cycle "<<node<<" "<<parent<<endl;
    if(par[node])
    {
        beg=node;
        en=parent;
        return;
    }
    par[node]=parent;

    if(to[node]!=parent)dfs_cycle(to[node],node);

    for(int i=seen[node];i<seen[node+1];i++)
        if(EDGE[i].first!=parent)dfs_cycle(EDGE[i].first,node);
}

pair<long long/*longest*/,long long/*diameter*/> solve_tree(int node)
{
    ret=0;
    where=0;
    dfs(node,0,0);

    long long mem=ret;
    dfs(where,0,0);

    return {mem,ret};
}
int order[nmax],id=0;
long long add[nmax*2];
int edge[nmax*2];
long long pref[nmax*2];
int eval(int a,int b)
{
    int ret=1e6;
    if(to[a]==b)ret=min(ret,cost[a]);
    if(to[b]==a)ret=min(ret,cost[b]);
    return ret;
}

deque< pair<long long/*where*/,long long/*add*/> > dq;

int main()
{
scanf("%i",&n);
for(int i=1;i<=n;i++)scanf("%i",&to[i]);
for(int i=1;i<=n;i++)scanf("%i",&cost[i]);

bool special=0;

for(int i=1;i<=n;i++)
{
    if(i==to[i])special=1;
    else seen[to[i]]++;
}


for(int i=1;i<=n;i++)
    seen[i]=seen[i-1]+seen[i];

seen[n+1]=seen[n]+1;

for(int i=1;i<=n;i++)
{
    if(i!=to[i])
    {
        EDGE[seen[to[i]]]={i,cost[i]};
        seen[to[i]]--;
    }
}
/*
for(int i=1;i<=n;i++)
    cout<<EDGE[i].first<<" "<<EDGE[i].second<<endl;
*/
for(int i=1;i<=n;i++)seen[i]++;
/*
for(int i=1;i<=n;i++)
    cout<<seen[i]<<" ";cout<<endl;
return 0;
*/
if(special)
{
   cout<<solve_tree(1).second<<endl;
    return 0;
}

dfs_cycle(1,1);

//cout<<beg<<" "<<en<<endl;
while(beg!=en)
{
    id++;
    order[id]=beg;
    beg=par[beg];
}

id++;
order[id]=beg;
//for(int i=1;i<=id;i++)cout<<order[i]<<" ";cout<<endl;

long long output=0;
for(int i=1;i<=id;i++)
    blocked[order[i]]=1;

for(int i=1;i<=id;i++)
{
    blocked[order[i]]=0;
    pair<long long/*longest*/,long long/*diameter*/> now=solve_tree(order[i]);
    //cout<<order[i]<<" -> "<<now.first<<" "<<now.second<<endl;
    ret=max(ret,now.second);
    add[i]=now.first;
    edge[i]=eval(order[i],order[(i+1<=id)?i+1:i+1-id]);
    blocked[order[i]]=1;
}
/*
for(int i=1;i<=id;i++)
    cout<<edge[i]<<" ";cout<<endl;
*/
for(int i=id+1;i<=2*id;i++)
    add[i]=add[i-id],edge[i]=edge[i-id];

for(int i=1;i<=2*id;i++)
    pref[i]=pref[i-1]+edge[i];

long long s=pref[id];

for(int i=1;i<=2*id;i++)
{
    while(dq.size()&&2*(pref[i-1]-dq.back().first)>=s)dq.pop_back();
    if(dq.size())
    {
        ret=max(ret,add[i]+pref[i-1]+dq.back().second);
    }

    while(dq.size()&&dq.front().first<=add[i]-pref[i-1])dq.pop_front();
    dq.push_front({pref[i-1],add[i]-pref[i-1]});
}

cout<<ret<<endl;
return 0;
}
/*
8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8

4
2 3 3 2
1 3 5 5
*/
