#include <iostream>
#include <vector>
#include <utility>
#define fi first
#define se second
using namespace std;

const int MAXN = 1000005;

int n;
int a[MAXN], b[MAXN], d[MAXN], p[MAXN];
vector<pair<int, int>> g[MAXN];
vector<int> c, w;

long long ans = 0;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i];
    }

    for (int i = 1; i <= n; ++ i)
    {
        g[i].emplace_back(a[i], b[i]);
        g[a[i]].emplace_back(i, b[i]);
    }
}

bool found = false;

void DFS(int u, int par)
{
    if (found) return;
    else p[u] = par;

    for (auto v : g[u])
    {
        if (p[v.fi] != 0)
        {
            int t = u;
            while (t != v.fi)
            {
                c.push_back(t);
                t = p[t];
            }
            c.push_back(v.fi);

            found = true;
            return;
        }

        if (v.fi != par) DFS(v.fi, u);
    }
}

void DDFS(int u, int par)
{
    p[u] = 1;

    for (auto v : g[u])
    {
        if (p[v.fi] == 0 and v.fi != par)
        {
            DDFS(v.fi, u);
            d[u] = max(d[u], d[v.fi] + v.se);
        }
    }
}

/*void update(int idx, int le, int ri, long long del, int v = 1, int l = 1, int r = c.size())
{
    if (le > r or l > ri) return;
    if (le <= l and r <= ri)
    {
        tdel[v][idx] += del;
        tmax[v][idx] += del;
        if (l != r)
        {
            tdel[v << 1 | 0][idx] += tdel[v][idx];
            tdel[v << 1 | 1][idx] += tdel[v][idx];
        }
        tdel[v][idx] = 0;
        return;
    }

    if (tdel[v] != 0)
    {
        tmax[v] += tdel[v];
        tdel[v << 1 | 0] += tdel[v];
        tdel[v << 1 | 1] += tdel[v];
        tdel[v] = 0;
    }

    int mid = (l + r) >> 1;
    update(le, ri, del, v << 1 | 0, l, mid + 0);
    update(le, ri, del, v << 1 | 1, mid + 1, r);

    tmax[v] = max(tmax[v << 1 | 0][idx], tmax[v << 1 | 0][idx]);
}*/

long long d1[MAXN], d2[MAXN];

void Solve(int idx)
{
    long long dist;
    for (int i = 0; i < c.size(); ++ i)
    {
        d1[i] = d2[i] = 0;
    }

    dist = 0;
    for (int i = idx; i < c.size(); ++ i)
    {
        d1[i] = dist;
        dist += w[i];
    }
    for (int i = 0; i < idx; ++ i)
    {
        d1[i] = dist;
        dist += w[i];
    }

    dist = 0;
    for (int i = idx - 1; i >= 0; -- i)
    {
        dist += w[i];
        d2[i] = dist;
    }
    for (int i = c.size() - 1; i > idx; -- i)
    {
        dist += w[i];
        d2[i] = dist;
    }

    for (int i = 0; i < c.size(); ++ i)
    {
        if (i == idx) continue;
        ans = max(ans, min(d1[i], d2[i]) + d[c[i]] + d[c[idx]]);

        //cout << idx << ' ' << i << ' ' << min(d1[i], d2[i]) << ' ' << d[i]  << ' ' << d[idx] << endl;
    }
}

int main()
{
    Init();
    DFS(1, -1);



    for (int i = 1; i <= n; ++ i)
    {
        p[i] = 0;
    }
    for (int i = 0; i < c.size(); ++ i)
    {
        p[c[i]] = 1;
    }

    for (int i = 0; i < c.size(); ++ i)
    {
        DDFS(c[i], -1);
        // cout << c[i] << ' ' << d[c[i]] << endl;
    }

    return 0;

    long long tot = 0;
    for (int i = 0; i < c.size(); ++ i)
    {
        int u = c[i];
        int v = (i == c.size() - 1) ? 0 : i + 1;

        for (int j = 0; j < g[u].size(); ++ j)
        {
            if (g[u][j].fi == v)
            {
                w.push_back(g[u][j].se);
                tot += g[u][j].se;
                break;
            }
        }
    }

    for (int i = 0; i < c.size(); ++ i)
    {
        Solve(i);
    }

   /* long long ans = 0;
    for (int i = 0; i < c.size(); ++ i)
    {
        ans = max(ans, max(tmax[1][0], tmax[1][1]) + d[i]);

        update(0, i + 1, c.size() - 1, -w[i]);
        update(0, i, i, tot);
        update(0, 0, i, -w[i]);

        update(1, 0, i, w[i]);
        update(1, i + 1, c.size() - 1, w[i])
    }*/


    cout << ans << endl;
    return 0;
}

/*
8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8
*/
