#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 1e5 + 5;

int n;
int p[N], c[N];
int actual[N];
vector <int> nb[N];

vector <pair <int, int> > ans;
int from_min, from_max;
int min_color, max_color;
void make_swap(int i, int j)
{
//    cerr << "MAKING SWAP " << i << " " << j << endl;
//    for(int i = 1; i <= n; i++)
//        cerr << actual[i] << " ";
//    cerr << endl;
//    cerr << actual[i] << " " << actual[j] << endl;

    int ci = c[actual[i]], cj = c[actual[j]];

    if(i == j)
        return;
    if(ci != cj)
        ans.pb({i, j});
    else
    {
        int assist = from_max;
        if(ci == max_color)
            assist = from_min;

        ans.pb({i, assist});
        ans.pb({i, j});
        ans.pb({j, assist});
    }

    swap(actual[i], actual[j]);

    if(ci == min_color)
        from_min = i;
    if(cj == min_color)
        from_min = j;
    if(ci == max_color)
        from_max = i;
    if(cj == max_color)
        from_max = j;

//    cerr << "DONE SWAP " << i << " " << j << endl;
//    for(int i = 1; i <= n; i++)
//        cerr << actual[i] << " ";
//    cerr << endl;
}

bool vis[N];
int path[N], path_sz;
bool found;
void DFS(int v, int par = -1)
{
    vis[v] = true;
    path[path_sz++] = v;
    for(int u: nb[v])
    {
        if(!vis[u])
            DFS(u, v);
        else
        {
            if(found)
                continue;
            found = true;
            int i = path_sz - 2;
            while(i >= 0)
            {
                make_swap(path[i], v);

                if(path[i] == u)
                    break;
                i--;
            }
        }
    }
    path_sz--;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> p[i];
        nb[i].pb(p[i]);
    }

    min_color = N;
    max_color = 0;
    for(int i = 1; i <= n; i++)
    {
        cin >> c[i];
        min_color = min(min_color, c[i]);
        max_color = max(max_color, c[i]);

        if(c[i] == min_color)
            from_min = i;
        if(c[i] == max_color)
            from_max = i;
    }

    for(int i = 1; i <= n; i++)
        actual[i] = i;

    for(int i = 1; i <= n; i++)
    {
        found = false;
        if(!vis[i])
            DFS(i);
    }

    for(int i = 1; i <= n; i++)
        assert(actual[i] == p[i]);

//    for(int i = 1; i <= n; i++)
//        cerr << actual[i] << " ";
//    cerr << endl;

    cout << (int)ans.size() << endl;
    for(auto x: ans)
        cout << x.first << " " << x.second << endl;


    return 0;
}

/*

7
2 5 3 7 1 6 4
3 2 2 3 3 2 3

*/
