#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctime>
#include <random>
#define pb push_back
#define mp make_pair
#define ll long long
#pragma gcc optimize ("O3")
#pragma gcc target ("sse4")
using namespace std;
const int N = 52;
const double TL = 1.4;

bool TimeOK()
{
    return clock() < TL * (double)CLOCKS_PER_SEC;
}

int n, L;
ll mask[N];

ll ans;
void print(ll x)
{
    for(int i = 0; i < L; i++)
    {
        if(x & (1LL << i))
            cout << 1;
        else
            cout << 0;
    }
    cout << endl;
}

void check(ll x)
{
    for(int i = 0; i < L; i++)
    {
        if((x & (1LL << i)) > (ans & (1LL << i)))
            ans = x;
        if((x & (1LL << i)) < (ans & (1LL << i)))
            break;
    }
}

mt19937 mt(313);
ll rng(ll l, ll r)
{
    return l + (mt() % (r - l));
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> L;
    string s;
    for(int i = 0; i < n; i++)
    {
        cin >> s;
        for(int j = 0; j < L; j++)
        {
            if(s[j] == '1')
                mask[i] |= (1LL << j);
        }
    }

    ll MAXX = (1LL << L) - 1;
    while(TimeOK())
    {
        ll i = rng(0, MAXX);

        ll blow = (1LL << L) - 1;
        ll cur = 0;
        for(int j = 0; j < n; j++)
        {
            if(i & (1LL << j))
            {
                ll blowing = cur & mask[j];
                blow ^= blowing;

                cur = (cur ^ mask[j]) & blow;
            }
        }

        check(cur);
    }

    print(ans);


    return 0;
}

/*

3 5
01101
10110
01011

*/
