#include <iostream>
#include <vector>
using namespace std;

typedef long long Int;

const int N=(1e5)+5;
const Int LMAX=(1e18);

vector <Int> g[N],len[N];
Int p[N],w[N];
Int dist[105][105];
Int ans;
bool used[N];

void DFS(int v,Int d)
{
 int i;

 used[v]=true;
 ans=max(ans,d);

  for(i=0;i<g[v].size();i++)
  {
    if(!used[g[v][i]])
     DFS(g[v][i],d+len[v][i]);
  }
}

int main()
{

ios::sync_with_stdio(false);
cin.tie(nullptr);

int n,i,j,k,root;

cin>>n;

 if(n<=100)
 {
   for(i=1;i<=n;i++)
    for(j=1;j<=n;j++)
     dist[i][j]=LMAX;

   for(i=1;i<=n;i++)
    dist[i][i]=0;

   for(i=1;i<=n;i++)
    cin>>p[i];

   for(i=1;i<=n;i++)
   {
    cin>>w[i];
    dist[i][p[i]]=w[i];
    dist[p[i]][i]=w[i];
   }

   for(k=1;k<=n;k++)
    for(i=1;i<=n;i++)
     for(j=1;j<=n;j++)
     {
      if(dist[i][k]+dist[k][j]<dist[i][j])
       dist[i][j]=dist[i][k]+dist[k][j];
     }

  ans=0;
   for(i=1;i<=n;i++)
    for(j=1;j<=n;j++)
     ans=max(ans,dist[i][j]);

  cout<<ans<<"\n";
  return 0;
 }

 for(i=1;i<=n;i++)
 {
  cin>>p[i];
  g[i].push_back(p[i]);
  g[p[i]].push_back(i);
 }

 for(i=1;i<=n;i++)
 {
  cin>>w[i];
  len[i].push_back(w[i]);
  len[p[i]].push_back(w[i]);

   if((int)g[i].size()==1 && g[i][0]!=i)
    root=i;
 }

DFS(root,0);

cout<<ans<<"\n";

return 0;
}
