#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cmath>

#define endl '\n'

using namespace std;

const int N = (int)(1e5) + 3;

int n, p, w;

long long res12;
int res11;

int dir[N];

vector< pair<int, int> > v[N];


long long dfs12(int u, int p) {
    if((int)v[u].size() == 1 && v[u][0].first == p) {
        return 0;
    }

    vector<long long> z;

    for(auto i : v[u]) {
        if(i.first != p) {
            z.push_back(i.second * 1LL + dfs12(i.first, u));
        }
    }

    sort(z.rbegin(), z.rend());
    res12 = max(res12, z[0] + z[1]);
    return z[0];
}

int dfs11(int u, int p) {
    if((int)v[u].size() == 1 && v[u][0].first == p) {
        res11 = max(res11, w);
        return 0;
    }

    vector<int> z;

    for(auto i : v[u]) {
        if(i.first != p) {
            z.push_back(i.second + dfs11(i.first, u));
        }
    }

    sort(z.rbegin(), z.rend());
    res11 = max(res11, z[0] + z[1]);
    return z[0];
}

int main() {
    //freopen("12.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    bool fl = 0;
    if(n < 10000) {
        fl = 1;
    }

    for(int i = 1; i <= n; ++i) {
        cin >> p;
        dir[i] = p;
    }

    for(int i = 1; i <= n; ++i) {
        cin >> w;
        if(fl) {
            if(dir[i] == i) res11 = max(res11, w);
            else {
                v[i].push_back(make_pair(dir[i], w));
                v[dir[i]].push_back(make_pair(i, w));
            }
        } else {
            res12 = max(res12, 1LL * w);
            if(dir[i] != i) {
                v[i].push_back(make_pair(dir[i], 1LL *w));
                v[dir[i]].push_back(make_pair(i, 1LL * w));
            }
        }
    }

    if(fl) dfs11(1, -1);
    else dfs12(1, -1);

    if(fl) cout << res11 << endl;
    else cout << res12 << endl;

    return 0;
}
