#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cmath>

#define endl '\n'

using namespace std;

const int N = (int)(1e5) + 3;

int n, p, w, res;
int dir[N];
vector< pair<int, int> > v[N];

int dfs(int u, int p) {
    if((int)v[u].size() == 1 && v[u][0].first == p) {
        return 0;
    }

    vector<int> z;

    for(auto i : v[u]) {
        if(i.first != p) {
            z.push_back(i.second + dfs(i.first, u));
        }
    }

    sort(z.rbegin(), z.rend());
    res = max(res, z[0] + z[1]);
    return z[0];
}

int main() {
    //freopen("12.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;

    for(int i = 1; i <= n; ++i) {
        cin >> p;
        dir[i] = p;
    }

    for(int i = 1; i <= n; ++i) {
        cin >> w;
        res = max(res, w);
        if(dir[i] != i) {
            v[i].push_back(make_pair(dir[i], w));
            v[dir[i]].push_back(make_pair(i, w));
        }
    }

    dfs(1, -1);

    cout << res << endl;

    return 0;
}
