#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 100007;

struct book_t {
  int num, color;
};

int ans_sz, n, pos[N];
book_t arr[N];
set < int > color_pos[N];
pair < int, int > ans[N * 3];
set < int > first_pos, last_pos;

int get_first(set < int > &a) {
  return *a.begin();
}

int get_last(set < int > &a) {
  return *prev(a.end());
}

void swap_positions(int i, int j) {
  if(arr[i].color!=arr[j].color) {
    first_pos.erase(get_first(color_pos[arr[i].color]));
    last_pos.erase(get_last(color_pos[arr[i].color]));

    first_pos.erase(get_first(color_pos[arr[j].color]));
    last_pos.erase(get_last(color_pos[arr[j].color]));

    color_pos[arr[i].color].erase(i);
    color_pos[arr[j].color].erase(j);
  }

  swap(arr[i], arr[j]);

  if(arr[i].color!=arr[j].color) {
    color_pos[arr[i].color].insert(i);
    color_pos[arr[j].color].insert(j);
  
    first_pos.insert(get_first(color_pos[arr[i].color]));
    last_pos.insert(get_last(color_pos[arr[i].color]));

    first_pos.insert(get_first(color_pos[arr[j].color]));
    last_pos.insert(get_last(color_pos[arr[j].color]));
  }

  pos[arr[i].num] = i;
  pos[arr[j].num] = j;

  ans[ans_sz++] = make_pair(i, j);
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j;

  scanf("%d", &n);
  for(i=1;i<=n;i++) {
    scanf("%d", &arr[i].num);
    pos[arr[i].num] = i;
  }
  for(i=1;i<=n;i++) {
    scanf("%d", &arr[i].color);
    
    color_pos[arr[i].color].insert(i);
  }

  for(i=1;i<=n;i++) {
    if(color_pos[i].empty()) continue;
    
    first_pos.insert(get_first(color_pos[i]));
    last_pos.insert(get_last(color_pos[i]));
  }

  while(true) {
    int swaps = 0;

    for(i=1;i<=n;i++) {
      if(arr[i].num==i) continue;

      if(arr[pos[i]].color!=arr[i].color) {
        swap_positions(i, pos[i]);
        ++swaps;
        continue;
      }
    }

    if(swaps==0) break;
  }

  for(i=1;i<=n;i++) {
    if(arr[i].num==i) continue;
    
    if(arr[pos[i]].color!=arr[i].color) {
      swap_positions(i, pos[i]);
      continue;
    }

    j = pos[i];

    int target = -1, cnt = 0;
    set < int >::iterator it;

    for(it=prev(last_pos.end());;it--) {
      if(*it<=i) break;
      if(arr[*it].color!=arr[i].color) {
        target = *it;
        break;
      }

      if(it==last_pos.begin()) break;
    }

    if(target!=-1) {
      swap_positions(i, target);
      swap_positions(i, j);
      continue;
    }

    for(it=first_pos.begin();it!=first_pos.end();it++) {
      if(arr[*it].color!=arr[i].color) {
        target = *it;
        break;
      }
    }

    /*(if(target==-1) {
      while(true) {}
    }*/

    swap_positions(i, target);
    swap_positions(i, j);
    swap_positions(j, target);
  }

  printf("%d\n", ans_sz);
  for(i=0;i<ans_sz;i++) {
    printf("%d %d\n", ans[i].first, ans[i].second);
  }

  return 0;
}
