#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 56;

int n, k;
long long ans, arr[N];
char str[N][N];
int next_bit[N][N], out[N], sz;
int v[N][N], v_sz[N];
long long save_powers[N];

void go(long long a, long long b, int current_bit) {
  if(current_bit>k) {
    ans = max(ans, (a ^ b));

    return;
  }

  int i;

  if(b & save_powers[k - current_bit]) {
    //Current bit is broken, transfers are taking place

    for(i=0;i<v_sz[current_bit];i++) {
      int next = next_bit[v[current_bit][i]][current_bit];
      
      if(next!=(-1)) {
        v[next][v_sz[next]++] = v[current_bit][i];
      }
    }

    go(a, b, current_bit + 1);

    //Clear transfers
    for(i=0;i<v_sz[current_bit];i++) {
      int next = next_bit[v[current_bit][i]][current_bit];

      if(next!=(-1)) {
        --v_sz[next];
      }
    }

    return;
  }

  if(a & save_powers[k - current_bit]) {
    //a has that bit so skip it

    go(a, b, current_bit + 1);
  }
  else {
    for(i=0;i<v_sz[current_bit];i++) {
      long long newa = a | arr[v[current_bit][i]], newb = b | (arr[v[current_bit][i]] & a);

      if((newa ^ newb) > (a ^ b)) {
        go(a | arr[v[current_bit][i]], b | (arr[v[current_bit][i]] & a), current_bit + 1);
      }
    }

    if(v_sz[current_bit]==0) {
      go(a, b, current_bit + 1);
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j;

  save_powers[0] = 1;
  for(i=1;i<N;i++) {
    save_powers[i] = (save_powers[i - 1] << 1);
  }

  cin>>n>>k;
  for(i=1;i<=n;i++) {
    int last = -1;
    
    cin>>(str[i] + 1);
    for(j=1;j<=k;j++) {
      arr[i] <<= 1;
      arr[i] |= (str[i][j] - '0');
    }

    for(j=k;j>=0;j--) {
      next_bit[i][j] = last;
      
      if(str[i][j]=='1') last = j;
    }

    if(last!=-1) {
      v[last][v_sz[last]++] = i;
    }
  }

  go(0, 0, 1);

  while(ans) {
    out[sz++] = ans & 1;
    ans >>= 1;
  }

  while(sz<k) out[sz++] = 0;

  reverse(out, out + k);
  for(i=0;i<k;i++) {
    printf("%d", out[i]);
  }
  printf("\n");

  return 0;
}
