#include <bits/stdc++.h>

using namespace std;

const long long N = 1e6 + 7;

vector<long long> adj[N], adj2[N];
vector<long long> pr[N];

long long par[N], pard[N];
short used[N];
vector<long long> cycle, cw;
long long d[N];

pair<long long, long long> cycle2;
long long min_d = 0;

void dfs(long long x){
    used[x] = 1;

    long long cnt_p = 0;

    for(long long i = 0; i < (long long)adj[x].size(); i++){
        long long u = adj[x][i];
        long long w = pr[x][i];

        if(used[u] == 2){
            continue;
        }
        if(u == par[x]){
            cnt_p++;

            if(cnt_p == 2){
                cycle2.first = u;
                cycle2.second = x;
                min_d = min(w, pard[x]);
            }

            continue;
        }

        if(used[u] == 1){
            cycle.clear();

            long long t = x;

            while(t != u){
                cycle.push_back(t);
                cw.push_back(pard[t]);
                t = par[t];
            }
            cycle.push_back(t);
            cw.push_back(w);
            continue;
        }

        pard[u] = w;
        par[u] = x;
        dfs(u);
    }

    used[x] = 2;
}

bool part[N];
long long sum = 0;

pair<long long, long long> find_diam(long long u, long long p){
    pair<long long, long long> ans = {0, 0};

    //used[u] = 1;

    long long cnt_p = 0;

    for(long long i = 0; i < (long long)adj[u].size(); i++){
        long long to = adj[u][i];
        long long w = pr[u][i];

        if(to == p){
            continue;
        }
        if(to == u){
            continue;
        }

        if((u == cycle2.first && to == cycle2.second) || (u == cycle2.second && to == cycle2.first)){
            w = min_d;
            cnt_p++;

            if(cnt_p == 2){
                continue;
            }
        }

        pair<long long, long long> t = find_diam(to, u);

        ans.first = max(ans.first, t.first);
        ans.first = max(ans.first, ans.second + t.second + w);
        ans.second = max(ans.second, t.second + w);
    }

    return ans;
}

long long n;

long long solve(){
    for(long long i = 1; i <= n; i++){
        used[i] = 0;
    }

    return find_diam(1, -1).first;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;

    for(long long i = 1; i <= n; i++){
        long long x;

        cin >> x;

        adj[i].push_back(x);
        adj[x].push_back(i);
    }

    for(long long i = 1; i <= n; i++){
        long long w;

        cin >> w;

        pr[i].push_back(w);
        pr[adj[i][pr[i].size() - 1]].push_back(w);
    }

    dfs(1);

    /*for(long long x: cycle){
        cout << x << " ";
    }
    cout << endl;

    for(long long w: cw){
        cout << w << " ";
    }
    cout << endl;*/

    if(cycle.empty()){
        cycle.push_back(1);
    }
    else{
        for(long long w: cw){
            sum += w;
        }
    }

    for(long long x: cycle){
        part[x] = true;
    }

    long long m = (long long)cycle.size();

    long long ans = solve();

    cout << ans << "\n";

    return 0;
}
/*
8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8
*/
