#include<iostream>
#include<vector>

using namespace std;

const int MAXN = 1e5 + 5;

int n;
int p[MAXN], c[MAXN];

int pos[MAXN];
vector < pair <int, int> > answer;

void doSwap(int i, int j)
{
    answer.push_back({i, j});

    pos[ p[i] ] = j;
    pos[ p[j] ] = i;

    swap(p[i], p[j]);
    swap(c[i], c[j]);
}

void specialSolve()
{
    for(int i = 1;i<=n;i++)
    {
        if(p[i]==i) continue;
        doSwap(i, pos[i]);
    }

    cout << answer.size() << '\n';
    for(int i = 0;i<answer.size();i++)
    {
        cout << answer[i].first << " " << answer[i].second << '\n';
    }

    for(int i = 1;i<=n;i++)
    {
        cout << p[i] << " ";
    }
    cout << '\n';

    exit(0);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int i = 1;i<=n;i++)
    {
        cin >> p[i];
        pos[ p[i] ] = i;
    }
    for(int i = 1;i<=n;i++)
    {
        cin >> c[i];
    }

    if(n<=30)
    {
        cout << 1/0 << '\n';
    }

    if(n>1000)
    {
        specialSolve();
    }

    for(int i = 1;i<=n;i++)
    {
        if(p[i]==i) continue;

        int index;
        for(int j = i+1;j<=n;j++)
        {
            if(p[j]==i)
            {
                index = j;
                continue;
            }
        }

        if(c[i]!=c[index])
        {
            doSwap(i, index);
        }
        else
        {
            int index1 = -1;
            for(int j = n;j>=1;j--)
            {
                if(c[j]!=c[i])
                {
                    index1 = j;
                    break;
                }
            }

            doSwap(i, index1);
            doSwap(i, index);
            if(index1<=i) doSwap(index, index1);
        }
    }

    cout << answer.size() << '\n';
    for(int i = 0;i<answer.size();i++)
    {
        cout << answer[i].first << " " << answer[i].second << '\n';
    }

    for(int i = 1;i<=n;i++)
    {
        cout << p[i] << " ";
    }
    cout << '\n';
}
/*
7
2 5 3 7 1 6 4
3 2 2 3 3 2 3
*/
