#include<iostream>
#include<bitset>

using namespace std;

int n, L;

struct state
{
    bitset <55> b, fail;

    state()
    {
        b.reset();
        fail.reset();
    }

    void update(bitset <55> &other)
    {
        for(int i = 0;i<L;i++)
        {
            if(other[i]==false) continue;

            if(this->b[i]==false && this->fail[i]==false) b[i] = true;
            else if(this->b[i]==true)
            {
                this->b[i] = false;
                this->fail[i] = true;
            }
        }
    }
};

bool operator >(const state A, const state B)
{
    for(int i = 0;i<L;i++)
    {
        if(A.b[i]==B.b[i]) continue;

        if(A.b[i]==true) return true;
        return false;
    }

    return false;
}

bitset <55> s[55];
state answer = state();

void rec(state curr, int index)
{
    if(index==n)
    {
        if(curr>answer) answer = curr;
        return;
    }

    //1
    rec(curr, index+1);

    //2

    curr.update(s[index]);
    rec(curr, index+1);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    string input;

    cin >> n >> L;
    for(int i = 0;i<n;i++)
    {
        cin >> input;
        for(int j = 0;j<L;j++)
        {
            s[i][j] = (bool)(input[j] - '0');
        }
    }

    state curr = state();
    rec(curr, 0);

    for(int i = 0;i<L;i++)
    {
        cout << answer.b[i];
    }
    cout << '\n';
}
/*
3 5
01101
10110
01011

10 20
00010111011100101010
11110001010110011110
00101010100100000100
11000000111011101000
01100101011001100100
11010010110010000100
01111111011000010001
00001010111010011111
11100011101000011011
10001000011001001111
*/
