#include<iostream>
#include<queue>
#include<vector>
using namespace std;

struct path
{
    int curnode;
    int len;

    path(){}

    path(int curnode_, int len_)
    {
        curnode=curnode_;
        len=len_;
    }

    /*
    bool operator<(path a)
    {
        return len<a.len;
    }
    */
};

bool operator <(const path &a, const path &b)
{
    return a.len>b.len;
}

int p[131072], w[131072];
int vis[131072], maxmax; ///0-unvisited -1-starting point
vector<path> v[131072];

int main()
{
    cin.tie(0);
    cout.tie(0);

    int n;
    int i,a;
    priority_queue<path> q;
    path tmp;
    /*
    path h=path(1,5),k=path(2,4), l=path(3,7), u=path(4,1);
    q.push(h), q.push(k), q.push(l), q.push(u);
    cout<<(q.top()).curnode<<" "<<(q.top()).len<<endl; q.pop();
    cout<<(q.top()).curnode<<" "<<(q.top()).len<<endl; q.pop();
    cout<<(q.top()).curnode<<" "<<(q.top()).len<<endl; q.pop();
    cout<<(q.top()).curnode<<" "<<(q.top()).len<<endl; q.pop();
    */

    cin>>n;

    for(i=0; i<n; i++)
    {
        cin>>a;
        p[i]=--a;
    }

    for(i=0; i<n; i++)
    {
        cin>>w[i];
        if(i!=p[i])
        {
            v[i].push_back(path(p[i],w[i]));
            v[p[i]].push_back(path(i,w[i]));
        }
    }

    for(a=0; a<n; a++)
    {
        for(i=0; i<n; i++) vis[i]=0;
        vis[a]=-1;

        q.push(path(a,0));
        while(!q.empty())
        {
            tmp=q.top();
            q.pop();
            for(i=0; i<v[tmp.curnode].size(); i++)
            {
                if(tmp.len+v[tmp.curnode][i].len<vis[v[tmp.curnode][i].curnode] || vis[v[tmp.curnode][i].curnode]==0)
                {
                    vis[v[tmp.curnode][i].curnode]=tmp.len+v[tmp.curnode][i].len;
                    q.push(path(v[tmp.curnode][i].curnode,tmp.len+v[tmp.curnode][i].len));
                }
            }
        }

        for(i=0;i<n;i++)
        {
            if(vis[i]>maxmax) maxmax=vis[i];
        }

    }

    cout<<maxmax<<endl;
    return 0;

}

/**
8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8
**/
