#include <bits/stdc++.h>

const int32_t MAX_N = 1e5;

int32_t n, a[MAX_N + 5], b[MAX_N + 5], pos[MAX_N + 5];

void solve_all_different() {
	std::vector< std::pair< int32_t, int32_t > > ans;

	while(1) {
		int32_t prior = 0;
		std::pair< int32_t, int32_t > bestMove;
				
		for(int32_t i = 1; i <= n; i++) {
			if(pos[i] == i) {
				continue;
			}

			if(a[i] == pos[i]) {
				prior = 2;
				bestMove = { i, pos[i] };
			}
			else if(prior != 2) {
				prior = 1;
				bestMove = { i, pos[i] };
			}
		}

		if(prior == 0) {
			break;
		}

		ans.push_back(bestMove);
		
		pos[a[bestMove.first]] = bestMove.second;
		pos[a[bestMove.second]] = bestMove.first;
		std::swap(a[bestMove.first], a[bestMove.second]);
	}

	std::cout << ans.size() << '\n';
	for(auto &x : ans) {
		std::cout << x.first << " " << x.second << '\n';
	}
}

void solve() {
	std::vector< std::pair< int32_t, int32_t > > ans;

	for(int32_t i = 1; i <= n; i++) {
		if(pos[i] == i) {
			continue;
		}

		if(b[pos[i]] != b[i]) {
			ans.push_back({ i, pos[i] });
			
			pos[a[i]] = pos[i];
			pos[i] = i;
			std::swap(a[i], a[pos[i]]);
			std::swap(b[i], b[pos[i]]);
		}
		else {
			for(int32_t j = i + 1; j <= n; j++) {
				if(b[j] != b[i]) {
					ans.push_back({ i, j });

					pos[a[i]] = j;
					pos[a[j]] = i;

					std::swap(a[i], a[j]);
					std::swap(b[i], b[j]);

					break;
				}
			}

			ans.push_back({ i, pos[i] });

			pos[a[i]] = pos[i];
			pos[i] = i;
			std::swap(a[i], a[pos[i]]);
			std::swap(b[i], b[pos[i]]);
		}
	}

	std::cout << ans.size() << '\n';
	for(auto &x : ans) {
		std::cout << x.first << " " << x.second << '\n';
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n;

	for(int32_t i = 1; i <= n; i++) {
		std::cin >> a[i];
		pos[a[i]] = i;
	}
	for(int32_t i = 1; i <= n; i++) {
		std::cin >> b[i];
	}

	solve();
}
