#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

#define NMax 1000000

struct node
{
    int v,w;
    node(){};
    node(int a,int b)
    {
        v=a,w=b;
    }
};

int n,maxdist[NMax+5],ans[NMax+5],maxans;
int arr[NMax+5],w[NMax+5];
bool used[NMax+5];
vector<node> nb[NMax+5];

int dfs(int v)
{
    used[v]=1;
    int best1=0,best2=0;

    for(int i=0;i<nb[v].size();i++)
    {
        if(used[nb[v][i].v])continue;

        int x=dfs(nb[v][i].v);
        if(x+nb[v][i].w>best1)
        {
            best2=best1;
            best1=x+nb[v][i].w;
        }
        else if(x+nb[v][i].w>best2)
            best2=x+nb[v][i].w;
    }

    ans[v]=best1+best2;

    return maxdist[v]=best1;
}

int main()
{
    scanf("%d",&n);

    for(int i=0;i<n;i++)
        scanf("%d",&arr[i]);

    for(int i=0;i<n;i++)
    {
        scanf("%d",&w[i]);

        nb[i+1].push_back(node(arr[i],w[i]));
        nb[arr[i]].push_back(node(i+1,w[i]));
    }


    dfs(7);

    for(int i=1;i<=n;i++)
        if(ans[i]>maxans)maxans=ans[i];

    printf("%d\n",maxans);

    return 0;
}
