#include<iostream>
#include<vector>
#include<queue>
#include<cstring>
#define MAX 1000010
#define INF 1000000000001
#define pb push_back
using namespace std;
struct road
{
    int to;
    int cost;
    road(){};
    road(int t, int c)
    {
        to=t;
        cost=c;
    }
    bool operator<(const road r) const
    {
        return cost>r.cost;
    }
};

vector <road> v[MAX];
int input[MAX];
int n;
int used[MAX];
long long d[MAX];
int vis[MAX];
long long dijkstra(int s)
{
    vis[s]=1;
    ///cout<<s<<" ";
    memset(used,0,sizeof(used));
    for(int a=1; a<=n; a++)
        d[a]=INF;
    d[s]=0;
    priority_queue <road> pq;
    pq.push(road(s,0));
    while(!pq.empty())
    {
        int s=pq.top().to;
        int w=pq.top().cost;
        pq.pop();
        used[s]=1;
        for(int a=0; a<v[s].size(); a++)
        {
            int g=v[s][a].to;
            int c=v[s][a].cost;
            if(!used[g] && d[s]+c<d[g])
            {
                d[g]=d[s]+c;
                pq.push(road(g,d[g]));
            }
        }
    }
    long long ans=0,t;
    for(int a=1; a<=n; a++)
    {
        if(ans<d[a])
        {
            ans=d[a];
            t=a;
        }
    }
    ///cout<<ans<<endl;
    vis[t]=1;
    return ans;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie();
    cin>>n;
    for(int a=1; a<=n; a++)
    {
        cin>>input[a];
    }
    for(int a=1;a<=n; a++)
    {
        int w;
        cin>>w;
        v[a].pb(road(input[a],w));
        v[input[a]].pb(road(a,w));
    }
    long long ans=0;
    for(int a=1; a<=n; a++)
    {
        if(v[a].size()==1 )
        {
            ans=max(ans,dijkstra(a));
        }
    }
    cout<<ans<<endl;
    return 0;
}
