#include<iostream>
#include<vector>
#include<queue>
using namespace std;

const int maxn = 1000000;
int n;

pair<int,int> e[2 * maxn];
vector<int> v[maxn];
bool visited[maxn];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 0; i < n; i ++)
    {
        int j;
        cin >> j;
        j --;
        e[2 * i].first = j;
        e[2 * i + 1].first = i;
        v[i].push_back(2 * i);
        v[j].push_back(2 * i + 1);
    }
    for(int i = 0; i < n; i ++)
    {
        int w;
        cin >> w;
        e[2 * i].second = w;
        e[2 * i + 1].second = w;
    }
    int max_dist = 0;
    int farthest = 0;
    int ans = 0;

    for(int _ = 0; _ < 2; _ ++)
    {
        priority_queue<pair<int,int> > q;
        q.push({0,farthest});
        max_dist = 0;
        for(int i = 0; i < n; i ++) visited[i] = 0;

        while(!q.empty())
        {
            pair<int,int> t = q.top();
            q.pop();
            if(visited[t.second])   continue;
            visited[t.second] = true;
            if(-t.first > max_dist)
            {
                max_dist = - t.first;
                farthest = t.second;
            }
            //cout << t.second + 1<< endl;
            for(int k = 0; k < v[t.second].size(); k ++)
            {
                int i = v[t.second][k];
                if(!visited[e[i].first])
                {
                    q.push({t.first - e[i].second, e[i].first});
                }
            }
        }
        ans = max(ans, max_dist);
        //cout << "~" << max_dist  << endl;
    }
    cout << ans;
}
/**
8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8
*/
