#include<iostream>
#include<vector>
using namespace std;

const int maxn = 100000;
int n;
int c[maxn];
int p[maxn];
int rp[maxn];

vector<pair<int,int> > op;

void bswap(int a, int b)
{
    swap(rp[p[a]], rp[p[b]]);
    swap(p[a], p[b]);
    op.push_back({a, b});
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 0; i < n; i ++)
    {
        cin >> p[i];
        p[i] --;
        rp[p[i]] = i;
    }
    for(int i = 0; i < n; i ++)
    {
        cin >> c[p[i]];
    }

    for(int i = 0; i < n; i ++)
    {
        if(rp[i] != i)
        {
            int _b = rp[i];
            int _a = i;
            if(c[p[_a]] != c[p[_b]])
            {
                //cout << p[_a] + 1 << " = " << c[p[_a]] << " " << p[_b] + 1 << " = " << c[p[_b]] << endl;
                bswap(_a, _b);
            } else {
                //cout << "HI" << i + 1 << endl;
                int _c = -1;
                for(int j = 0; _c == -1 &&  j < n; j ++)
                {
                    if(c[p[j]] != c[p[_a]])
                    {
                        _c = j;
                    }
                }
                bswap(_c, _a);
                bswap(_a, _b);
                bswap(_c, _b);
            }
        }
    }
    cout << op.size() << "\n";
    for(int i = 0; i < op.size(); i ++)
    {
        cout << op[i].first + 1 << " " << op[i].second + 1 << "\n";
    }
}
/**
7
2 5 3 7 1 6 4
3 2 2 3 3 2 3
*/
