#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 100003
using namespace std;
typedef long long ll;
typedef long double ld;
int n;
pair <int, int> perm[MAXN];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> perm[i].first;
    for (int i = 1; i <= n; i++)
        cin >> perm[i].second;
}
vector <pair <int, int> > ans;
void swapo(int i, int j)
{
    swap(perm[i], perm[j]);
    ans.push_back({i, j});
}
void solve()
{
    for (int i = 1; i <= n; i++)
    {
        int curr_pos;
        for (int j = i; j <= n; j++)
            if (perm[j].first == i)
            {
                curr_pos = j;
                break;
            }
            if (curr_pos == i)
                continue;
        if (perm[curr_pos].second != perm[i].second)
            swapo(curr_pos, i);
        else
        {
            int swap_pos = -1;
            for (int j = i; j <= n; j++)
            if (perm[j].second != perm[i].second)
            {
                swap_pos = j;
                break;
            }
            if (swap_pos != -1)
            {
                swapo(i, swap_pos);
                swapo(curr_pos, i);
            }
            else
            {
                for (int j = 1; j < i; j++)
                    if (perm[j].second != perm[i].second)
                {
                    swap_pos = j;
                    break;
                }
                swapo(swap_pos, curr_pos);
                swapo(i, curr_pos);
                swapo(swap_pos, i);
            }
        }
    }
    cout << ans.size() << endl;
    for (auto i: ans)
        cout << i.first << " " << i.second << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
/*
7
2 5 3 7 1 6 4
3 2 2 3 3 2 3
*/
