#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 53
using namespace std;
typedef long long ll;
typedef long double ld;
vector <ll> v1, v2;
ll c[MAXN];
int n, l;
void read()
{
    cin >> n >> l;
    for (int i = 1; i <= n; i++)
        for (ll j = l - 1; j >= 0; j--)
        {
            char ch;
            cin >> ch;
            if (ch == '1')
                c[i] += (1ll << j);
        }
}
struct node
{
    node *left, *right;
    node() {left = right = nullptr;}
    void insert(ll num, ll bit)
    {
        if (bit == -1)
            return;
        if (num & (1ll << bit))
        {
            if (right == nullptr)
                right = new node();
            right->insert(num, bit - 1);
        }
        else
        {
            if (left == nullptr)
                left = new node();
            left->insert(num, bit - 1);
        }
    }
    ll find(ll num, ll bit)
    {
        if (bit == -1)
            return 0;
        if (num & (1ll << bit))
        {
            if (left != nullptr)
                return (1ll << bit) + left->find(num, bit - 1);
            else
                return right->find(num, bit - 1);
        }
        else
        {
            if (right != nullptr)
                return (1ll << bit) + right->find(num, bit - 1);
            else
                return left->find(num, bit - 1);
        }
    }
};
node *root = new node();
void gen1(int pos, ll curr)
{
    if (pos == n / 2 + 1)
    {
        v1.push_back(curr);
        return;
    }
    gen1(pos + 1, curr);
    gen1(pos + 1, curr ^ c[pos]);
}
void gen2(int pos, ll curr)
{
    if (pos == n + 1)
    {
        v2.push_back(curr);
        return;
    }
    gen2(pos + 1, curr);
    gen2(pos + 1, curr ^ c[pos]);
}
void solve()
{
    gen1(1, 0);
    gen2(n / 2 + 1, 0);
    ll ans = -1;
    for (auto i: v2)
        {
            ans = max(ans, i);
            root->insert(i, l - 1);
        }
    for (auto i: v1)
        ans = max(ans, root->find(i, l - 1));
    for (ll i = l - 1; i >= 0; i--)
    {
        if (ans & (1ll << i))
            cout << 1;
        else
            cout << 0;
    }
    cout << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
