#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1000003
#define INF 1000000000000000
using namespace std;
typedef long long ll;
typedef long double ld;
ll n;
vector <pair <ll, ll> > adj[MAXN];
pair <ll, ll> nb[MAXN];
void read()
{
    cin >> n;
    for (ll i = 1; i <= n; i++)
        cin >> nb[i].first;
        for (ll i = 1; i <= n; i++)
            cin >> nb[i].second;
}
ll depth[MAXN];
ll ans = 0;
void dfs(ll ver, ll par)
{
    depth[ver] = 0;
   multiset <ll> s;
    for (auto i: adj[ver])
        if (i.first != par)
    {
        dfs(i.first, ver);
        s.insert(depth[i.first] + i.second);
    }
    ll max1, max2;
    if (s.size() == 0)
        max1 = max2 = 0;
    if (s.size() == 1)
    {
        max1 = *s.begin();
        max2 = 0;
    }
    if (s.size() >= 2)
    {
        max1 = *prev(s.end());
        max2 = *prev(prev(s.end()));
    }
    ans = max(ans, max1 + max2);
    depth[ver] = max1;
}
ll d[MAXN];
void dejstra(ll start)
{
    set <pair <ll, ll> > s;
    for (ll i = 1; i <= n; i++)
        d[i] = INF;
    d[start] = 0;
    s.insert({0, start});
    while (!s.empty())
    {
        auto curr = *s.begin();
        s.erase(s.begin());
        for (auto i: adj[curr.second])
            if (curr.first + i.second < d[i.first])
        {
            if (d[i.first] != INF)
            s.erase({d[i.first], i.first});
            d[i.first] = curr.first + i.second;
            s.insert({d[i.first], i.first});
        }
    }
}
void solve()
{
    bool is = false;
    for (ll i = 1; i <= n; i++)
    {
        if (nb[i].first == i)
            is = true;
        else
        {
            adj[i].push_back({nb[i].first, nb[i].second});
            adj[nb[i].first].push_back({i, nb[i].second});
        }
    }
    if (is)
    {
        dfs(1, -1);
        cout << ans << endl;
    }
    else
    {
        for (ll i = 1; i <= n; i++)
        {
            dejstra(i);
            for (ll j = 1; j <= n; j++)
                ans = max(ans, d[j]);
        }
        cout << ans << endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
