#pragma GCC optimize "Ofast"
#include <iostream>
#include <vector>

#define D(x) std::cout << __LINE__ << ": " << #x << " = " << x << std::endl;

const int MAX_N = 1e5 + 10;
int p[MAX_N], c[MAX_N];
int ptoi[MAX_N];
int n;

std::vector<std::pair<int, int>> ans;

void swap(int a, int b) {
	std::swap(c[a], c[b]);
	std::swap(p[a], p[b]);
	ptoi[p[a]] = a;
	ptoi[p[b]] = b;
	ans.push_back({a, b});
}

void fix(int tarp) {
	if(ptoi[tarp] == tarp-1) return;

	int idxX = ptoi[tarp];
	int idxY = tarp-1;

	//D(idxX);
	//D(idxY);

	if(c[idxX] != c[idxY]) {
		swap(idxX, idxY);
		return;
	}

	// 3 way swap
	//std::cout << "here" << std::endl;
	
	int idxZ = -1;
	for(int i = tarp;i < n;i ++) {
		if(c[i] != c[idxX]) {
			idxZ = i;
			break;
		}
	}

	if(idxZ == -1) while(1) {}

	swap(idxX, idxZ);
	swap(idxX, idxY);
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n;
	for(int i = 0;i < n;i ++) {
		std::cin >> p[i];
		ptoi[p[i]] = i;
	}
	for(int i = 0;i < n;i ++) std::cin >> c[i];

	for(int i = 1;i <= n;i ++) {
		fix(i);
	}

	std::cout << ans.size() << '\n';
	for(auto a : ans) {
		std::cout << a.first+1 << ' ' << a.second+1 << '\n';
	}
	return 0;
}
