#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int lamps, switches;
vector<int> on[50];
string input[50];

vector <string> found;

//bool cmp (pair< string, string> a, pair<string, string> b)

void solve(int idx, string curr, string isDead)
{
    //cout << idx << ' ' << curr << '\n';
    if (idx == lamps)
    {
        //cout << curr << '\n';
        found.push_back(curr);
        return;
    }

    vector <pair <string, string> > possible;
    for (int i = 0; i < on[idx].size(); ++i)
    {
        bool ok = true;
        for (int j = 0; j < idx; ++j)
        {
            if (curr[j] == '1' and input[on[idx][i]][j] == '1')
            {
                ok = false;
                break;
            }
        }

        if (ok)
        {
            //vector<int> die;

            string neww = curr;
            string newIsDead = isDead;
            for (int j = idx; j < lamps; ++j)
            {
                // cout << j << ' ' << input[on[idx][i]][j] << ' ' << dead[j] << '\n';
                if (input[on[idx][i]][j] == '1')
                {
                    if (neww[j] == '0' and newIsDead[j] == '0')
                    {
                        neww[j] = '1';
                        //cout << "+\n";
                    }
                    else if (neww[j] == '1')
                    {
                        neww[j] = '0';
                        newIsDead[j] = '1';
                        //die.push_back(j);
                        //cout << "-\n";
                    }
                }
            }
            possible.push_back(make_pair(neww, newIsDead));

            /*for (int j = 0; j < die.size(); ++j)
            {
                dead[die[j]] = false;
            }
            found = true;*/
        }
    }

    if (possible.size() == 0)
    {
        solve(idx + 1, curr, isDead);
    }
    else
    {
        sort(possible.begin(), possible.end());
        /*cout << "asd\n";
        for (int i = 0; i < possible.size(); ++i)
        {
            cout << possible[i].first << ' ' << possible[i].second << '\n';
        }
        cout << "asd\n";*/
        solve(idx + 1, possible[possible.size() - 1].first, possible[possible.size() - 1].second);
    }
}

int main  ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    cin >> switches >> lamps;

    for (int i = 0; i < switches; ++i)
    {
        cin >> input[i];

        for (int j = 0; j < lamps; ++j)
        {
            if (input[i][j] == '1')
            {
                on[j].push_back(i);
            }
        }
    }

    string start = "";
    for (int i = 0; i < lamps; ++i)
    {
        start += '0';
    }
    solve(0, start, start);

    sort(found.begin(), found.end());

    cout << found[found.size() - 1] << '\n';

    return 0;
}
